/* ViewCollection.c generated by valac 0.20.1, the Vala compiler
 * generated from ViewCollection.vala, do not modify */

/* Copyright 2011-2013 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* A ViewCollection holds DataView objects, which are view instances wrapping DataSource objects.*/
/* Thus, multiple views can exist of a single SourceCollection, each view displaying all or some*/
/* of that SourceCollection.  A view collection also has a notion of order*/
/* (first/last/next/previous) that can be overridden by child classes.  It also understands hidden*/
/* objects, which are withheld entirely from the collection until they're made visible.  Currently*/
/* the only way to hide objects is with a ViewFilter.*/
/**/
/* A ViewCollection may also be locked.  When locked, it will not (a) remove hidden items from the*/
/* collection and (b) remove DataViews representing unlinked DataSources.  This allows for the*/
/* ViewCollection to be "frozen" while manipulating items within it.  When the collection is*/
/* unlocked, all changes are applied at once.*/
/**/
/* The default implementation provides a browser which orders the view in the order they're*/
/* stored in DataCollection, which is not specified.*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_VIEW_FILTER (view_filter_get_type ())
#define VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_FILTER, ViewFilter))
#define VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_FILTER, ViewFilterClass))
#define IS_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_FILTER))
#define IS_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_FILTER))
#define VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_FILTER, ViewFilterClass))

typedef struct _ViewFilter ViewFilter;
typedef struct _ViewFilterClass ViewFilterClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define VIEW_COLLECTION_TYPE_MONITOR (view_collection_monitor_get_type ())
#define VIEW_COLLECTION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor))
#define VIEW_COLLECTION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))
#define VIEW_COLLECTION_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))

typedef struct _ViewCollectionMonitor ViewCollectionMonitor;
typedef struct _ViewCollectionMonitorClass ViewCollectionMonitorClass;

#define VIEW_COLLECTION_TYPE_MONITOR_IMPL (view_collection_monitor_impl_get_type ())
#define VIEW_COLLECTION_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl))
#define VIEW_COLLECTION_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))
#define VIEW_COLLECTION_IS_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_IS_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_MONITOR_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))

typedef struct _ViewCollectionMonitorImpl ViewCollectionMonitorImpl;
typedef struct _ViewCollectionMonitorImplClass ViewCollectionMonitorImplClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))
typedef struct _ViewCollectionMonitorPrivate ViewCollectionMonitorPrivate;
typedef struct _ViewCollectionMonitorImplPrivate ViewCollectionMonitorImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_RATING (rating_get_type ())

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;
typedef struct _ViewCollectionParamSpecMonitor ViewCollectionParamSpecMonitor;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))
typedef struct _ViewManagerPrivate ViewManagerPrivate;
typedef struct _ParamSpecViewManager ParamSpecViewManager;
typedef struct _ViewFilterPrivate ViewFilterPrivate;
typedef struct _ParamSpecViewFilter ParamSpecViewFilter;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected_unselected) (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_items_shown) (ViewCollection* self, GeeCollection* shown);
	void (*notify_items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*notify_items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*notify_view_filter_installed) (ViewCollection* self, ViewFilter* filter);
	void (*notify_view_filter_removed) (ViewCollection* self, ViewFilter* filter);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_first_unrejected) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeCollection* visible);
	void (*items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*view_filter_installed) (ViewCollection* self, ViewFilter* filer);
	void (*view_filter_removed) (ViewCollection* self, ViewFilter* filer);
};

typedef DataView* (*CreateView) (DataSource* source, void* user_data);
typedef gboolean (*CreateViewPredicate) (DataSource* source, void* user_data);
struct _ViewCollectionPrivate {
	GeeHashMultiMap* monitors;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	CreateViewPredicate should_mirror;
	gpointer should_mirror_target;
	GeeSet* filters;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewCollectionMonitorPrivate * priv;
};

struct _ViewCollectionMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (ViewCollectionMonitor *self);
};

struct _ViewCollectionMonitorImpl {
	ViewCollectionMonitor parent_instance;
	ViewCollectionMonitorImplPrivate * priv;
	ViewCollection* owner;
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* prereq;
};

struct _ViewCollectionMonitorImplClass {
	ViewCollectionMonitorClass parent_class;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, void* user_data);
struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};

struct _ViewCollectionParamSpecMonitor {
	GParamSpec parent_instance;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

struct _ViewFilter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewFilterPrivate * priv;
};

struct _ViewFilterClass {
	GTypeClass parent_class;
	void (*finalize) (ViewFilter *self);
	gboolean (*predicate) (ViewFilter* self, DataView* view);
	void (*refresh) (ViewFilter* self);
};

struct _ParamSpecViewFilter {
	GParamSpec parent_instance;
};


static gpointer view_collection_parent_class = NULL;
static gpointer view_collection_monitor_parent_class = NULL;
static gpointer view_collection_monitor_impl_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_filter_parent_class = NULL;

gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
GType marker_get_type (void) G_GNUC_CONST;
GType view_collection_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
gpointer view_filter_ref (gpointer instance);
void view_filter_unref (gpointer instance);
GParamSpec* param_spec_view_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_filter (GValue* value, gpointer v_object);
void value_take_view_filter (GValue* value, gpointer v_object);
gpointer value_get_view_filter (const GValue* value);
GType view_filter_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer view_collection_monitor_ref (gpointer instance);
void view_collection_monitor_unref (gpointer instance);
GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void view_collection_value_set_monitor (GValue* value, gpointer v_object);
void view_collection_value_take_monitor (GValue* value, gpointer v_object);
gpointer view_collection_value_get_monitor (const GValue* value);
GType view_collection_monitor_get_type (void) G_GNUC_CONST;
static GType view_collection_monitor_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
#define VIEW_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_VIEW_COLLECTION, ViewCollectionPrivate))
enum  {
	VIEW_COLLECTION_DUMMY_PROPERTY
};
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
ViewCollection* view_collection_new (const gchar* name);
ViewCollection* view_collection_construct (GType object_type, const gchar* name);
DataCollection* data_collection_new (const gchar* name);
DataCollection* data_collection_construct (GType object_type, const gchar* name);
void view_collection_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
static void view_collection_real_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
void view_collection_notify_selection_group_altered (ViewCollection* self);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view);
void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view);
void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views);
void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown);
static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown);
void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden);
void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
void view_collection_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter);
void view_collection_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter);
static void view_collection_real_clear (DataCollection* base);
gchar* data_collection_to_string (DataCollection* self);
void data_collection_clear (DataCollection* self);
static void view_collection_real_close (DataCollection* base);
void view_collection_halt_all_monitoring (ViewCollection* self);
void view_collection_halt_mirroring (ViewCollection* self);
static void view_collection_on_view_filter_refresh (ViewCollection* self);
static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender, gpointer self);
void data_collection_close (DataCollection* self);
gpointer view_manager_ref (gpointer instance);
void view_manager_unref (gpointer instance);
GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_view_manager (GValue* value, gpointer v_object);
void value_take_view_manager (GValue* value, gpointer v_object);
gpointer value_get_view_manager (const GValue* value);
GType view_manager_get_type (void) G_GNUC_CONST;
ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target);
void data_collection_freeze_notifications (DataCollection* self);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq);
DataView* view_manager_create_view (ViewManager* self, DataSource* source);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target);
GeeCollection* data_collection_get_all (DataCollection* self);
void data_collection_thaw_notifications (DataCollection* self);
void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m);
void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target, CreateViewPredicate should_mirror, void* should_mirror_target);
void data_collection_set_comparator (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
Comparator data_collection_get_comparator (DataCollection* self, void** result_target);
ComparatorPredicate data_collection_get_comparator_predicate (DataCollection* self, void** result_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
void view_collection_copy_into (ViewCollection* self, ViewCollection* to_copy, CreateView copying_ctor, void* copying_ctor_target, CreateViewPredicate should_copy, void* should_copy_target);
DataSource* data_view_get_source (DataView* self);
gboolean view_collection_is_view_filter_installed (ViewCollection* self, ViewFilter* f);
void view_collection_install_view_filter (ViewCollection* self, ViewFilter* f);
void view_collection_remove_view_filter (ViewCollection* self, ViewFilter* f);
static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views);
static gboolean view_collection_is_in_filter (ViewCollection* self, DataView* view);
gboolean view_filter_predicate (ViewFilter* self, DataView* view);
static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object);
static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added);
gboolean view_manager_include_in_view (ViewManager* self, DataSource* source);
static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self);
gboolean data_collection_add (DataCollection* self, DataObject* object);
static gboolean view_collection_real_add (DataCollection* base, DataObject* object);
void data_view_internal_set_visible (DataView* self, gboolean visible);
GeeCollection* data_collection_get_singleton (DataObject* object);
static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed);
Marker* data_collection_start_marking (DataCollection* self);
void marker_mark (Marker* self, DataObject* object);
gint marker_get_count (Marker* self);
void data_collection_remove_marked (DataCollection* self, Marker* m);
static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items);
gboolean alteration_contains_any (Alteration* self, Alteration* other);
gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source);
gboolean data_set_contains (DataSet* self, DataObject* object);
gboolean data_set_resort_object (DataSet* self, DataObject* object, Alteration* alteration);
static gboolean view_collection_is_visible (ViewCollection* self, DataView* view);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
void data_collection_notify_ordering_changed (DataCollection* self);
static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added);
gboolean data_view_is_selected (DataView* self);
gboolean data_view_is_visible (DataView* self);
static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many);
static void view_collection_add_many_selected (ViewCollection* self, GeeCollection* views);
void data_collection_notify_items_added (DataCollection* self, GeeIterable* added);
static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed);
gboolean data_set_remove (DataSet* self, DataObject* object);
static void view_collection_remove_many_selected (ViewCollection* self, GeeCollection* views);
void data_collection_notify_items_removed (DataCollection* self, GeeIterable* removed);
static void view_collection_show_items (ViewCollection* self, GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base, GeeMap* map);
static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
void data_set_set_comparator (DataSet* self, Comparator user_comparator, void* user_comparator_target, ComparatorPredicate comparator_predicate, void* comparator_predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
void data_set_reset_comparator (DataSet* self);
void data_collection_reset_comparator (DataCollection* self);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
GeeList* data_set_get_all (DataSet* self);
GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
gint data_set_get_count (DataSet* self);
gint data_collection_get_count (DataCollection* self);
gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base, gint index);
DataObject* data_set_get_at (DataSet* self, gint index);
DataObject* data_collection_get_at (DataCollection* self, gint index);
static gint view_collection_real_index_of (DataCollection* base, DataObject* object);
gint data_set_index_of (DataSet* self, DataObject* object);
gint data_collection_index_of (DataCollection* self, DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base, DataObject* object);
gboolean data_collection_contains (DataCollection* self, DataObject* object);
DataView* view_collection_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first (ViewCollection* self);
DataView* view_collection_get_first_unrejected (ViewCollection* self);
static DataView* view_collection_real_get_first_unrejected (ViewCollection* self);
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType rating_get_type (void) G_GNUC_CONST;
Rating media_source_get_rating (MediaSource* self);
DataView* view_collection_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_last (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view);
DataView* view_collection_get_previous (ViewCollection* self, DataView* view);
static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view);
gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const gchar* type_selector);
gchar* data_source_get_typename (DataSource* self);
GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const gchar* typename);
gboolean data_set_add_many (DataSet* self, GeeCollection* objects);
gboolean data_set_remove_many (DataSet* self, GeeCollection* objects);
void view_collection_select_marked (ViewCollection* self, Marker* marker);
void data_collection_act_on_marked (DataCollection* self, Marker* m, MarkedAction action, void* action_target, ProgressMonitor monitor, void* monitor_target, GObject* user);
static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_select_all (ViewCollection* self);
void marker_mark_all (Marker* self);
void data_view_internal_set_selected (DataView* self, gboolean selected);
void view_collection_unselect_marked (ViewCollection* self, Marker* marker);
static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self);
void view_collection_unselect_all (ViewCollection* self);
void marker_mark_many (Marker* self, GeeCollection* list);
GeeList* view_collection_get_selected (ViewCollection* self);
void view_collection_unselect_all_but (ViewCollection* self, DataView* exception);
void view_collection_unselect_and_select_marked (ViewCollection* self, Marker* unselect, Marker* select);
void view_collection_toggle_marked (ViewCollection* self, Marker* marker);
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self);
gboolean data_view_internal_toggle (DataView* self);
gint view_collection_get_selected_count (ViewCollection* self);
DataView* view_collection_get_selected_at (ViewCollection* self, gint index);
DataSet* data_collection_get_dataset_copy (DataCollection* self);
gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self, DataSource* source);
DataView* view_collection_get_view_for_source_filtered (ViewCollection* self, DataSource* source);
GeeCollection* view_collection_get_sources (ViewCollection* self);
gboolean view_collection_has_source_of_type (ViewCollection* self, GType t);
gint view_collection_get_sources_of_type_count (ViewCollection* self, GType t);
GeeList* view_collection_get_sources_of_type (ViewCollection* self, GType t);
GeeList* view_collection_get_selected_sources (ViewCollection* self);
DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index);
GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self, GType t);
gint view_collection_index_of_source (ViewCollection* self, DataSource* source);
void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_notify_thawed (DataCollection* base);
void data_collection_notify_thawed (DataCollection* self);
gboolean view_collection_are_items_filtered_out (ViewCollection* self);
static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected);
static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected);
static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed);
static void view_collection_real_selection_group_altered (ViewCollection* self);
static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible);
static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden);
static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed);
static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view);
static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views);
static void view_collection_real_view_filter_installed (ViewCollection* self, ViewFilter* filer);
static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void view_collection_real_view_filter_removed (ViewCollection* self, ViewFilter* filer);
enum  {
	VIEW_COLLECTION_MONITOR_DUMMY_PROPERTY
};
ViewCollectionMonitor* view_collection_monitor_new (void);
ViewCollectionMonitor* view_collection_monitor_construct (GType object_type);
static void view_collection_monitor_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_MONITOR_IMPL_DUMMY_PROPERTY
};
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj);
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_DUMMY_PROPERTY
};
static void view_collection_toggle_lists_finalize (GObject* obj);
static void view_collection_finalize (DataCollection* obj);
enum  {
	VIEW_MANAGER_DUMMY_PROPERTY
};
static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source);
ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager* obj);
enum  {
	VIEW_FILTER_DUMMY_PROPERTY
};
static gboolean view_filter_real_predicate (ViewFilter* self, DataView* view);
ViewFilter* view_filter_construct (GType object_type);
static void view_filter_real_refresh (ViewFilter* self);
static void view_filter_finalize (ViewFilter* obj);


ViewCollection* view_collection_construct (GType object_type, const gchar* name) {
	ViewCollection* self = NULL;
	const gchar* _tmp0_;
#line 126 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 127 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = name;
#line 127 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, _tmp0_);
#line 126 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self;
#line 708 "ViewCollection.c"
}


ViewCollection* view_collection_new (const gchar* name) {
#line 126 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 715 "ViewCollection.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self ? g_object_ref (self) : NULL;
#line 722 "ViewCollection.c"
}


static void view_collection_real_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected) {
	gboolean _tmp0_ = FALSE;
	GeeCollection* _tmp1_;
	gboolean _tmp5_;
	gboolean has_selected;
	gboolean _tmp6_ = FALSE;
	GeeCollection* _tmp7_;
	gboolean _tmp11_;
	gboolean has_unselected;
	gboolean _tmp12_;
	gboolean _tmp14_;
	GeeCollection* sum = NULL;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_;
	gboolean _tmp19_;
	GeeCollection* _tmp37_;
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail ((selected == NULL) || GEE_IS_COLLECTION (selected));
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail ((unselected == NULL) || GEE_IS_COLLECTION (unselected));
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = selected;
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 750 "ViewCollection.c"
		GeeCollection* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = selected;
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = gee_collection_get_size (_tmp2_);
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_ > 0;
#line 762 "ViewCollection.c"
	} else {
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = FALSE;
#line 766 "ViewCollection.c"
	}
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = _tmp0_;
#line 132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	has_selected = _tmp5_;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = unselected;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp7_ != NULL) {
#line 776 "ViewCollection.c"
		GeeCollection* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp8_ = unselected;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp9_ = gee_collection_get_size (_tmp8_);
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp10_ = _tmp9_;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = _tmp10_ > 0;
#line 788 "ViewCollection.c"
	} else {
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = FALSE;
#line 792 "ViewCollection.c"
	}
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp11_ = _tmp6_;
#line 133 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	has_unselected = _tmp11_;
#line 135 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp12_ = has_selected;
#line 135 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp12_) {
#line 802 "ViewCollection.c"
		GeeCollection* _tmp13_;
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp13_ = selected;
#line 136 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_signal_emit_by_name (self, "items-selected", G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ITERABLE, GeeIterable));
#line 808 "ViewCollection.c"
	}
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp14_ = has_unselected;
#line 138 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp14_) {
#line 814 "ViewCollection.c"
		GeeCollection* _tmp15_;
#line 139 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp15_ = unselected;
#line 139 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_signal_emit_by_name (self, "items-unselected", G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ITERABLE, GeeIterable));
#line 820 "ViewCollection.c"
	}
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp17_ = has_selected;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp17_) {
#line 826 "ViewCollection.c"
		gboolean _tmp18_;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp18_ = has_unselected;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp16_ = !_tmp18_;
#line 832 "ViewCollection.c"
	} else {
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp16_ = FALSE;
#line 836 "ViewCollection.c"
	}
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp19_ = _tmp16_;
#line 142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp19_) {
#line 842 "ViewCollection.c"
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
#line 143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp20_ = selected;
#line 143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (sum);
#line 143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		sum = _tmp21_;
#line 853 "ViewCollection.c"
	} else {
		gboolean _tmp22_ = FALSE;
		gboolean _tmp23_;
		gboolean _tmp25_;
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp23_ = has_selected;
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (!_tmp23_) {
#line 862 "ViewCollection.c"
			gboolean _tmp24_;
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp24_ = has_unselected;
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp22_ = _tmp24_;
#line 868 "ViewCollection.c"
		} else {
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp22_ = FALSE;
#line 872 "ViewCollection.c"
		}
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp25_ = _tmp22_;
#line 144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp25_) {
#line 878 "ViewCollection.c"
			GeeCollection* _tmp26_;
			GeeCollection* _tmp27_;
#line 145 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp26_ = unselected;
#line 145 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 145 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (sum);
#line 145 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			sum = _tmp27_;
#line 889 "ViewCollection.c"
		} else {
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_;
			gboolean _tmp31_;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp29_ = has_selected;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp29_) {
#line 898 "ViewCollection.c"
				gboolean _tmp30_;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp30_ = has_unselected;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp28_ = !_tmp30_;
#line 904 "ViewCollection.c"
			} else {
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp28_ = FALSE;
#line 908 "ViewCollection.c"
			}
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp31_ = _tmp28_;
#line 146 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp31_) {
#line 147 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 147 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				sum = NULL;
#line 918 "ViewCollection.c"
			} else {
				GeeHashSet* _tmp32_;
				GeeCollection* _tmp33_;
				GeeCollection* _tmp34_;
				GeeCollection* _tmp35_;
				GeeCollection* _tmp36_;
#line 149 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp32_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 149 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 149 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				sum = G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_COLLECTION, GeeCollection);
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp33_ = sum;
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp34_ = selected;
#line 150 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp33_, _tmp34_);
#line 151 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp35_ = sum;
#line 151 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp36_ = unselected;
#line 151 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp35_, _tmp36_);
#line 943 "ViewCollection.c"
			}
		}
	}
#line 154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp37_ = sum;
#line 154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp37_ != NULL) {
#line 951 "ViewCollection.c"
		GeeCollection* _tmp38_;
#line 155 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp38_ = sum;
#line 155 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_signal_emit_by_name (self, "items-state-changed", G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ITERABLE, GeeIterable));
#line 156 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 959 "ViewCollection.c"
	}
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (sum);
#line 963 "ViewCollection.c"
}


void view_collection_notify_items_selected_unselected (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected) {
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_selected_unselected (self, selected, unselected);
#line 972 "ViewCollection.c"
}


static void view_collection_real_notify_selection_group_altered (ViewCollection* self) {
#line 161 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "selection-group-altered");
#line 979 "ViewCollection.c"
}


void view_collection_notify_selection_group_altered (ViewCollection* self) {
#line 160 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 160 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_selection_group_altered (self);
#line 988 "ViewCollection.c"
}


static void view_collection_real_notify_item_view_altered (ViewCollection* self, DataView* view) {
	DataView* _tmp0_;
#line 164 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = view;
#line 165 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "item-view-altered", _tmp0_);
#line 1000 "ViewCollection.c"
}


void view_collection_notify_item_view_altered (ViewCollection* self, DataView* view) {
#line 164 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 164 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_view_altered (self, view);
#line 1009 "ViewCollection.c"
}


static void view_collection_real_notify_views_altered (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
#line 168 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 169 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 169 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "views-altered", _tmp0_);
#line 1021 "ViewCollection.c"
}


void view_collection_notify_views_altered (ViewCollection* self, GeeCollection* views) {
#line 168 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 168 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_views_altered (self, views);
#line 1030 "ViewCollection.c"
}


static void view_collection_real_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
	DataView* _tmp0_;
#line 172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 173 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = view;
#line 173 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "item-geometry-altered", _tmp0_);
#line 1042 "ViewCollection.c"
}


void view_collection_notify_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_item_geometry_altered (self, view);
#line 1051 "ViewCollection.c"
}


static void view_collection_real_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
#line 176 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 177 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 177 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "geometries-altered", _tmp0_);
#line 1063 "ViewCollection.c"
}


void view_collection_notify_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 176 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 176 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_geometries_altered (self, views);
#line 1072 "ViewCollection.c"
}


static void view_collection_real_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
	GeeCollection* _tmp0_;
#line 180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (shown));
#line 181 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = shown;
#line 181 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "items-shown", _tmp0_);
#line 1084 "ViewCollection.c"
}


void view_collection_notify_items_shown (ViewCollection* self, GeeCollection* shown) {
#line 180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_shown (self, shown);
#line 1093 "ViewCollection.c"
}


static void view_collection_real_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
	GeeCollection* _tmp0_;
#line 184 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = hidden;
#line 185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "items-hidden", _tmp0_);
#line 1105 "ViewCollection.c"
}


void view_collection_notify_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 184 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 184 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_hidden (self, hidden);
#line 1114 "ViewCollection.c"
}


static void view_collection_real_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
	GeeCollection* _tmp0_;
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 189 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = changed;
#line 189 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "items-visibility-changed", _tmp0_);
#line 1126 "ViewCollection.c"
}


void view_collection_notify_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 188 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_items_visibility_changed (self, changed);
#line 1135 "ViewCollection.c"
}


static void view_collection_real_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter) {
	ViewFilter* _tmp0_;
#line 192 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filter));
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = filter;
#line 193 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "view-filter-installed", _tmp0_);
#line 1147 "ViewCollection.c"
}


void view_collection_notify_view_filter_installed (ViewCollection* self, ViewFilter* filter) {
#line 192 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 192 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_installed (self, filter);
#line 1156 "ViewCollection.c"
}


static void view_collection_real_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter) {
	ViewFilter* _tmp0_;
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filter));
#line 197 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = filter;
#line 197 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_emit_by_name (self, "view-filter-removed", _tmp0_);
#line 1168 "ViewCollection.c"
}


void view_collection_notify_view_filter_removed (ViewCollection* self, ViewFilter* filter) {
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 196 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_GET_CLASS (self)->notify_view_filter_removed (self, filter);
#line 1177 "ViewCollection.c"
}


static void view_collection_real_clear (DataCollection* base) {
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	GeeHashMultiMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp5_;
#line 200 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = gee_multi_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp3_ > 0) {
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 1200 "ViewCollection.c"
	} else {
		ViewCollection* _tmp4_;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->mirroring;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1207 "ViewCollection.c"
	}
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = _tmp0_;
#line 203 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp5_) {
#line 1213 "ViewCollection.c"
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
#line 204 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = data_collection_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 204 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = _tmp6_;
#line 204 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_warning ("ViewCollection.vala:204: Cannot clear %s: monitoring or mirroring in e" \
"ffect", _tmp7_);
#line 204 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_free0 (_tmp7_);
#line 206 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return;
#line 1226 "ViewCollection.c"
	}
#line 209 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1230 "ViewCollection.c"
}


static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender, gpointer self) {
#line 216 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 1237 "ViewCollection.c"
}


static void view_collection_real_close (DataCollection* base) {
	ViewCollection * self;
	GeeSet* _tmp8_;
#line 212 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 213 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 214 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 1250 "ViewCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _f_it;
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1263 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			ViewFilter* f;
			ViewFilter* _tmp6_;
			guint _tmp7_ = 0U;
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 1279 "ViewCollection.c"
			}
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _f_it;
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp5_;
#line 216 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = f;
#line 216 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp7_, NULL, FALSE);
#line 216 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 1295 "ViewCollection.c"
		}
#line 215 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 1299 "ViewCollection.c"
	}
#line 217 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = self->priv->filters;
#line 217 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 219 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1307 "ViewCollection.c"
}


ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self, SourceCollection* sources, ViewManager* manager, Alteration* prereq, GeeCollection* initial, ProgressMonitor progress_monitor, void* progress_monitor_target) {
	ViewCollectionMonitor* result = NULL;
	SourceCollection* _tmp0_;
	ViewManager* _tmp1_;
	Alteration* _tmp2_;
	ViewCollectionMonitorImpl* _tmp3_;
	ViewCollectionMonitorImpl* monitor;
	GeeHashMultiMap* _tmp4_;
	SourceCollection* _tmp5_;
	ViewCollectionMonitorImpl* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GeeCollection* _tmp8_;
	gboolean _tmp12_;
#line 222 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 222 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail ((initial == NULL) || GEE_IS_COLLECTION (initial), NULL);
#line 226 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 228 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_freeze_notifications (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = sources;
#line 231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = manager;
#line 231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = prereq;
#line 231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = view_collection_monitor_impl_new (self, _tmp0_, _tmp1_, _tmp2_);
#line 231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	monitor = _tmp3_;
#line 232 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = self->priv->monitors;
#line 232 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = sources;
#line 232 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = monitor;
#line 232 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp5_, _tmp6_);
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = initial;
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp8_ != NULL) {
#line 1360 "ViewCollection.c"
		GeeCollection* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp9_ = initial;
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp10_ = gee_collection_get_size (_tmp9_);
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp11_ = _tmp10_;
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = _tmp11_ > 0;
#line 1372 "ViewCollection.c"
	} else {
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = FALSE;
#line 1376 "ViewCollection.c"
	}
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp12_ = _tmp7_;
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp12_) {
#line 1382 "ViewCollection.c"
		GeeArrayList* _tmp13_;
		GeeArrayList* created_views;
		GeeArrayList* _tmp25_;
		ProgressMonitor _tmp26_;
		void* _tmp26__target;
		GeeCollection* _tmp27_ = NULL;
		GeeCollection* _tmp28_;
#line 236 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp13_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 236 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		created_views = _tmp13_;
#line 1394 "ViewCollection.c"
		{
			GeeCollection* _tmp14_;
			GeeIterator* _tmp15_ = NULL;
			GeeIterator* _source_it;
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = initial;
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_source_it = _tmp15_;
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			while (TRUE) {
#line 1407 "ViewCollection.c"
				GeeIterator* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GeeIterator* _tmp18_;
				gpointer _tmp19_ = NULL;
				DataSource* source;
				GeeArrayList* _tmp20_;
				ViewManager* _tmp21_;
				DataSource* _tmp22_;
				DataView* _tmp23_ = NULL;
				DataView* _tmp24_;
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = _source_it;
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp17_ = gee_iterator_next (_tmp16_);
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!_tmp17_) {
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					break;
#line 1426 "ViewCollection.c"
				}
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp18_ = _source_it;
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = gee_iterator_get (_tmp18_);
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				source = (DataSource*) _tmp19_;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp20_ = created_views;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp21_ = manager;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp22_ = source;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp23_ = view_manager_create_view (_tmp21_, _tmp22_);
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp24_ = _tmp23_;
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp24_);
#line 238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp24_);
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1450 "ViewCollection.c"
			}
#line 237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_source_it);
#line 1454 "ViewCollection.c"
		}
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp25_ = created_views;
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp26_ = progress_monitor;
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp26__target = progress_monitor_target;
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp27_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection), _tmp26_, _tmp26__target);
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp28_ = _tmp27_;
#line 240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp28_);
#line 234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (created_views);
#line 1470 "ViewCollection.c"
	} else {
		SourceCollection* _tmp29_;
		SourceCollection* _tmp30_;
		GeeCollection* _tmp31_ = NULL;
		GeeIterable* _tmp32_;
		ProgressMonitor _tmp33_;
		void* _tmp33__target;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp29_ = sources;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp30_ = sources;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp31_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_DATA_COLLECTION, DataCollection));
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp32_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ITERABLE, GeeIterable);
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp33_ = progress_monitor;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp33__target = progress_monitor_target;
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_add_sources (self, _tmp29_, _tmp32_, _tmp33_, _tmp33__target);
#line 243 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp32_);
#line 1494 "ViewCollection.c"
	}
#line 246 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_thaw_notifications (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (monitor, VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor);
#line 248 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 1502 "ViewCollection.c"
}


static gpointer _view_collection_monitor_ref0 (gpointer self) {
#line 252 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self ? view_collection_monitor_ref (self) : NULL;
#line 1509 "ViewCollection.c"
}


void view_collection_halt_monitoring (ViewCollection* self, ViewCollectionMonitor* m) {
	ViewCollectionMonitor* _tmp0_;
	ViewCollectionMonitorImpl* _tmp1_;
	ViewCollectionMonitorImpl* monitor;
	GeeHashMultiMap* _tmp2_;
	SourceCollection* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean removed;
#line 251 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 251 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (VIEW_COLLECTION_IS_MONITOR (m));
#line 252 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = m;
#line 252 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = _view_collection_monitor_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl));
#line 252 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	monitor = _tmp1_;
#line 254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->monitors;
#line 254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = monitor->sources;
#line 254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = gee_multi_map_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp3_, monitor);
#line 254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	removed = _tmp4_;
#line 255 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 251 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_view_collection_monitor_unref0 (monitor);
#line 1543 "ViewCollection.c"
}


void view_collection_halt_all_monitoring (ViewCollection* self) {
	GeeHashMultiMap* _tmp0_;
#line 258 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 259 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->monitors;
#line 259 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	gee_multi_map_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 1555 "ViewCollection.c"
}


static gpointer _data_collection_ref0 (gpointer self) {
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self ? data_collection_ref (self) : NULL;
#line 1562 "ViewCollection.c"
}


static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added (self, added);
#line 1569 "ViewCollection.c"
}


static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 277 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_removed (self, removed);
#line 1576 "ViewCollection.c"
}


void view_collection_mirror (ViewCollection* self, ViewCollection* to_mirror, CreateView mirroring_ctor, void* mirroring_ctor_target, CreateViewPredicate should_mirror, void* should_mirror_target) {
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	CreateView _tmp2_;
	void* _tmp2__target;
	CreateViewPredicate _tmp3_;
	void* _tmp3__target;
	ViewCollection* _tmp4_;
	void* _tmp5_ = NULL;
	Comparator _tmp6_ = NULL;
	ViewCollection* _tmp7_;
	void* _tmp8_ = NULL;
	ComparatorPredicate _tmp9_ = NULL;
	ViewCollection* _tmp10_;
	GeeCollection* _tmp11_ = NULL;
	GeeCollection* _tmp12_;
	ViewCollection* _tmp13_;
	ViewCollection* _tmp14_;
#line 262 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 262 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
#line 264 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 265 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 266 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = to_mirror;
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = _data_collection_ref0 (_tmp0_);
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 268 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->mirroring = _tmp1_;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = mirroring_ctor;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2__target = mirroring_ctor_target;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = _tmp2_;
#line 269 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = _tmp2__target;
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = should_mirror;
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3__target = should_mirror_target;
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->should_mirror = _tmp3_;
#line 270 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->should_mirror_target = _tmp3__target;
#line 271 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = to_mirror;
#line 271 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_comparator (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_COLLECTION, DataCollection), &_tmp5_);
#line 271 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = to_mirror;
#line 271 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp9_ = data_collection_get_comparator_predicate (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_COLLECTION, DataCollection), &_tmp8_);
#line 271 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_set_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp6_, _tmp5_, _tmp9_, _tmp8_);
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp10_ = self->priv->mirroring;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp11_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_COLLECTION, DataCollection));
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp12_ = _tmp11_;
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 274 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp12_);
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp13_ = self->priv->mirroring;
#line 276 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_COLLECTION, DataCollection), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 277 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp14_ = self->priv->mirroring;
#line 277 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_DATA_COLLECTION, DataCollection), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1660 "ViewCollection.c"
}


void view_collection_halt_mirroring (ViewCollection* self) {
	ViewCollection* _tmp0_;
#line 280 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 281 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->mirroring;
#line 281 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 1672 "ViewCollection.c"
		ViewCollection* _tmp1_;
		guint _tmp2_ = 0U;
		ViewCollection* _tmp3_;
		guint _tmp4_ = 0U;
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = self->priv->mirroring;
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 282 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 283 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = self->priv->mirroring;
#line 283 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp4_, NULL, FALSE);
#line 283 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1689 "ViewCollection.c"
	}
#line 286 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 286 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 1695 "ViewCollection.c"
}


void view_collection_copy_into (ViewCollection* self, ViewCollection* to_copy, CreateView copying_ctor, void* copying_ctor_target, CreateViewPredicate should_copy, void* should_copy_target) {
	GeeArrayList* _tmp0_;
	GeeArrayList* copy_view;
	GeeArrayList* _tmp25_;
	GeeCollection* _tmp26_ = NULL;
	GeeCollection* _tmp27_;
#line 289 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 289 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_copy));
#line 292 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 292 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	copy_view = _tmp0_;
#line 1713 "ViewCollection.c"
	{
		ViewCollection* _tmp1_;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = to_copy;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_COLLECTION, DataCollection));
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1737 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			DataObject* _tmp10_;
			DataView* _tmp11_;
			DataView* view;
			CreateViewPredicate _tmp12_;
			void* _tmp12__target;
			DataView* _tmp13_;
			DataSource* _tmp14_ = NULL;
			DataSource* _tmp15_;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 1761 "ViewCollection.c"
			}
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 294 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 294 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_VIEW, DataView));
#line 294 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = _tmp11_;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = should_copy;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12__target = should_copy_target;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = view;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = data_view_get_source (_tmp13_);
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = _tmp14_;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp16_ = _tmp12_ (_tmp15_, _tmp12__target);
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp17_ = _tmp16_;
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp15_);
#line 295 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp17_) {
#line 1793 "ViewCollection.c"
				GeeArrayList* _tmp18_;
				CreateView _tmp19_;
				void* _tmp19__target;
				DataView* _tmp20_;
				DataSource* _tmp21_ = NULL;
				DataSource* _tmp22_;
				DataView* _tmp23_ = NULL;
				DataView* _tmp24_;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp18_ = copy_view;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = copying_ctor;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19__target = copying_ctor_target;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp20_ = view;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp21_ = data_view_get_source (_tmp20_);
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp22_ = _tmp21_;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp23_ = _tmp19_ (_tmp22_, _tmp19__target);
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp24_ = _tmp23_;
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_DATA_OBJECT, DataObject));
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp24_);
#line 296 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp22_);
#line 1824 "ViewCollection.c"
			}
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 1830 "ViewCollection.c"
		}
#line 293 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 1834 "ViewCollection.c"
	}
#line 299 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp25_ = copy_view;
#line 299 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp26_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 299 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp27_ = _tmp26_;
#line 299 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp27_);
#line 289 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (copy_view);
#line 1846 "ViewCollection.c"
}


gboolean view_collection_is_view_filter_installed (ViewCollection* self, ViewFilter* f) {
	gboolean result = FALSE;
	GeeSet* _tmp0_;
	ViewFilter* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 302 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 302 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_FILTER (f), FALSE);
#line 303 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 303 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = f;
#line 303 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), _tmp1_);
#line 303 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp2_;
#line 303 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 1869 "ViewCollection.c"
}


void view_collection_install_view_filter (ViewCollection* self, ViewFilter* f) {
	ViewFilter* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GeeSet* _tmp2_;
	ViewFilter* _tmp3_;
	ViewFilter* _tmp4_;
	ViewFilter* _tmp5_;
#line 306 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 306 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (f));
#line 307 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = f;
#line 307 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_is_view_filter_installed (self, _tmp0_);
#line 307 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_) {
#line 308 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return;
#line 1892 "ViewCollection.c"
	}
#line 310 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->filters;
#line 310 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = f;
#line 310 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection), _tmp3_);
#line 311 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = f;
#line 311 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_connect (_tmp4_, "refresh", (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 314 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 317 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = f;
#line 317 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_notify_view_filter_installed (self, _tmp5_);
#line 1910 "ViewCollection.c"
}


void view_collection_remove_view_filter (ViewCollection* self, ViewFilter* f) {
	ViewFilter* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GeeSet* _tmp2_;
	ViewFilter* _tmp3_;
	ViewFilter* _tmp4_;
	guint _tmp5_ = 0U;
	ViewFilter* _tmp6_;
#line 320 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 320 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (f));
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = f;
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_is_view_filter_installed (self, _tmp0_);
#line 321 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp1_) {
#line 322 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return;
#line 1934 "ViewCollection.c"
	}
#line 324 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = self->priv->filters;
#line 324 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = f;
#line 324 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection), _tmp3_);
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = f;
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp5_, NULL, FALSE);
#line 325 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 328 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 331 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = f;
#line 331 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_notify_view_filter_removed (self, _tmp6_);
#line 1954 "ViewCollection.c"
}


static void view_collection_on_view_filter_refresh (ViewCollection* self) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_;
#line 334 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 335 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 335 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 335 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 335 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1971 "ViewCollection.c"
}


static gboolean view_collection_is_in_filter (ViewCollection* self, DataView* view) {
	gboolean result = FALSE;
#line 339 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 339 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 1981 "ViewCollection.c"
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _f_it;
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 1994 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			ViewFilter* f;
			ViewFilter* _tmp6_;
			DataView* _tmp7_;
			gboolean _tmp8_ = FALSE;
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 2011 "ViewCollection.c"
			}
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _f_it;
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp5_;
#line 341 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = f;
#line 341 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 341 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = view_filter_predicate (_tmp6_, _tmp7_);
#line 341 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp8_) {
#line 342 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				result = FALSE;
#line 342 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_view_filter_unref0 (f);
#line 342 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_f_it);
#line 342 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				return result;
#line 2035 "ViewCollection.c"
			}
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 2039 "ViewCollection.c"
		}
#line 340 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 2043 "ViewCollection.c"
	}
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 344 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 2049 "ViewCollection.c"
}


static gboolean view_collection_real_valid_type (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	DataObject* _tmp0_;
#line 347 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 347 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 348 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 348 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_DATA_VIEW);
#line 348 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 2067 "ViewCollection.c"
}


static void view_collection_on_sources_added (ViewCollection* self, DataCollection* sources, GeeIterable* added) {
	DataCollection* _tmp0_;
	GeeIterable* _tmp1_;
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (sources));
#line 351 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 352 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = sources;
#line 352 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = added;
#line 352 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_add_sources (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp1_, NULL, NULL);
#line 2086 "ViewCollection.c"
}


static DataView* _view_manager_create_view_create_view (DataSource* source, gpointer self) {
	DataView* result;
	result = view_manager_create_view (self, source);
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 2095 "ViewCollection.c"
}


static void view_collection_add_sources (ViewCollection* self, SourceCollection* sources, GeeIterable* added, ProgressMonitor progress_monitor, void* progress_monitor_target) {
	DataView* created_view;
	GeeArrayList* created_views;
	DataView* _tmp37_;
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 359 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	created_view = NULL;
#line 360 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	created_views = NULL;
#line 2113 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = added;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_source_it = _tmp1_;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2126 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataSource* source;
			CreateView factory;
			void* factory_target;
			GDestroyNotify factory_target_destroy_notify;
			CreateView _tmp22_;
			void* _tmp22__target;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 2145 "ViewCollection.c"
			}
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _source_it;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp5_;
#line 362 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			factory = NULL;
#line 362 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			factory_target = NULL;
#line 362 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 2159 "ViewCollection.c"
			{
				GeeHashMultiMap* _tmp6_;
				SourceCollection* _tmp7_;
				GeeCollection* _tmp8_ = NULL;
				GeeCollection* _tmp9_;
				GeeIterator* _tmp10_ = NULL;
				GeeIterator* _tmp11_;
				GeeIterator* _monitor_it;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp6_ = self->priv->monitors;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp7_ = sources;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp8_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp7_);
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp9_ = _tmp8_;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp11_ = _tmp10_;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp9_);
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_monitor_it = _tmp11_;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				while (TRUE) {
#line 2186 "ViewCollection.c"
					GeeIterator* _tmp12_;
					gboolean _tmp13_ = FALSE;
					GeeIterator* _tmp14_;
					gpointer _tmp15_ = NULL;
					ViewCollectionMonitorImpl* monitor;
					ViewCollectionMonitorImpl* _tmp16_;
					ViewManager* _tmp17_;
					DataSource* _tmp18_;
					gboolean _tmp19_ = FALSE;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp12_ = _monitor_it;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp13_ = gee_iterator_next (_tmp12_);
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (!_tmp13_) {
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						break;
#line 2204 "ViewCollection.c"
					}
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp14_ = _monitor_it;
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp15_ = gee_iterator_get (_tmp14_);
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					monitor = (ViewCollectionMonitorImpl*) _tmp15_;
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp16_ = monitor;
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp17_ = _tmp16_->manager;
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp18_ = source;
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp19_ = view_manager_include_in_view (_tmp17_, _tmp18_);
#line 364 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp19_) {
#line 2222 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp20_;
						ViewManager* _tmp21_;
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp20_ = monitor;
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp21_ = _tmp20_->manager;
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						factory = NULL;
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						factory_target = NULL;
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						factory_target_destroy_notify = NULL;
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						factory = _view_manager_create_view_create_view;
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						factory_target = view_manager_ref (_tmp21_);
#line 365 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						factory_target_destroy_notify = view_manager_unref;
#line 367 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 367 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						break;
#line 2247 "ViewCollection.c"
					}
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor);
#line 2251 "ViewCollection.c"
				}
#line 363 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_it);
#line 2255 "ViewCollection.c"
			}
#line 371 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp22_ = factory;
#line 371 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp22__target = factory_target;
#line 371 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp22_ != NULL) {
#line 2263 "ViewCollection.c"
				CreateView _tmp23_;
				void* _tmp23__target;
				DataSource* _tmp24_;
				DataView* _tmp25_ = NULL;
				DataView* new_view;
				GeeArrayList* _tmp26_;
#line 372 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp23_ = factory;
#line 372 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp23__target = factory_target;
#line 372 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp24_ = source;
#line 372 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp25_ = _tmp23_ (_tmp24_, _tmp23__target);
#line 372 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				new_view = _tmp25_;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp26_ = created_views;
#line 376 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp26_ != NULL) {
#line 2284 "ViewCollection.c"
					GeeArrayList* _tmp27_;
					DataView* _tmp28_;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp27_ = created_views;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp28_ = new_view;
#line 377 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp28_);
#line 2293 "ViewCollection.c"
				} else {
					DataView* _tmp29_;
#line 378 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp29_ = created_view;
#line 378 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp29_ == NULL) {
#line 2300 "ViewCollection.c"
						DataView* _tmp30_;
						DataView* _tmp31_;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp30_ = new_view;
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp31_ = _g_object_ref0 (_tmp30_);
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 379 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						created_view = _tmp31_;
#line 2311 "ViewCollection.c"
					} else {
						GeeArrayList* _tmp32_;
						GeeArrayList* _tmp33_;
						DataView* _tmp34_;
						GeeArrayList* _tmp35_;
						DataView* _tmp36_;
#line 381 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp32_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 381 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_g_object_unref0 (created_views);
#line 381 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						created_views = _tmp32_;
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp33_ = created_views;
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp34_ = created_view;
#line 382 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp34_);
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 383 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						created_view = NULL;
#line 384 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp35_ = created_views;
#line 384 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp36_ = new_view;
#line 384 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp36_);
#line 2340 "ViewCollection.c"
					}
				}
#line 371 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (new_view);
#line 2345 "ViewCollection.c"
			}
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			factory = NULL;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			factory_target = NULL;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2357 "ViewCollection.c"
		}
#line 361 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2361 "ViewCollection.c"
	}
#line 389 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp37_ = created_view;
#line 389 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp37_ != NULL) {
#line 2367 "ViewCollection.c"
		DataView* _tmp38_;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp38_ = created_view;
#line 390 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_DATA_OBJECT, DataObject));
#line 2373 "ViewCollection.c"
	} else {
		gboolean _tmp39_ = FALSE;
		GeeArrayList* _tmp40_;
		gboolean _tmp44_;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp40_ = created_views;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp40_ != NULL) {
#line 2382 "ViewCollection.c"
			GeeArrayList* _tmp41_;
			gint _tmp42_;
			gint _tmp43_;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp41_ = created_views;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp42_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GEE_TYPE_COLLECTION, GeeCollection));
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp43_ = _tmp42_;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp39_ = _tmp43_ > 0;
#line 2394 "ViewCollection.c"
		} else {
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp39_ = FALSE;
#line 2398 "ViewCollection.c"
		}
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp44_ = _tmp39_;
#line 391 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp44_) {
#line 2404 "ViewCollection.c"
			GeeArrayList* _tmp45_;
			ProgressMonitor _tmp46_;
			void* _tmp46__target;
			GeeCollection* _tmp47_ = NULL;
			GeeCollection* _tmp48_;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp45_ = created_views;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp46_ = progress_monitor;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp46__target = progress_monitor_target;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp47_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_COLLECTION, GeeCollection), _tmp46_, _tmp46__target);
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp48_ = _tmp47_;
#line 392 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp48_);
#line 2422 "ViewCollection.c"
		}
	}
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (created_views);
#line 355 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (created_view);
#line 2429 "ViewCollection.c"
}


static gboolean view_collection_real_add (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataObject* _tmp1_;
	gboolean _tmp2_ = FALSE;
	DataObject* _tmp3_;
	GeeCollection* _tmp4_ = NULL;
	GeeCollection* _tmp5_;
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 395 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 396 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_VIEW, DataView), TRUE);
#line 398 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = object;
#line 398 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp1_);
#line 398 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp2_) {
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = FALSE;
#line 399 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 2460 "ViewCollection.c"
	}
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = object;
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = data_collection_get_singleton (_tmp3_);
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection);
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp5_);
#line 401 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp5_);
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 403 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 2476 "ViewCollection.c"
}


static GeeCollection* view_collection_real_add_many (DataCollection* base, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target) {
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp7_;
	ProgressMonitor _tmp8_;
	void* _tmp8__target;
	GeeCollection* _tmp9_ = NULL;
	GeeCollection* return_list;
#line 406 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 406 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (objects), NULL);
#line 2492 "ViewCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = objects;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2505 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			DataObject* _tmp6_;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 2520 "ViewCollection.c"
			}
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp5_;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = object;
#line 409 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_VIEW, DataView), TRUE);
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2534 "ViewCollection.c"
		}
#line 408 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2538 "ViewCollection.c"
	}
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = objects;
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = monitor;
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8__target = monitor_target;
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp9_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp7_, _tmp8_, _tmp8__target);
#line 411 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return_list = _tmp9_;
#line 413 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, G_TYPE_CHECK_INSTANCE_CAST (return_list, GEE_TYPE_COLLECTION, GeeCollection));
#line 415 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = return_list;
#line 415 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 2556 "ViewCollection.c"
}


static void view_collection_on_sources_removed (ViewCollection* self, GeeIterable* removed) {
	Marker* marker;
	gboolean _tmp14_ = FALSE;
	Marker* _tmp15_;
	gboolean _tmp18_;
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 420 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	marker = NULL;
#line 2571 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = removed;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_source_it = _tmp1_;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2584 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataSource* source;
			GeeHashMap* _tmp6_;
			DataSource* _tmp7_;
			gpointer _tmp8_ = NULL;
			DataView* view;
			DataView* _tmp9_;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 2603 "ViewCollection.c"
			}
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _source_it;
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp5_;
#line 422 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 422 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = source;
#line 422 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp7_);
#line 422 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = (DataView*) _tmp8_;
#line 425 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 425 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp9_ != NULL) {
#line 2623 "ViewCollection.c"
				Marker* _tmp10_;
				Marker* _tmp12_;
				DataView* _tmp13_;
#line 426 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp10_ = marker;
#line 426 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp10_ == NULL) {
#line 2631 "ViewCollection.c"
					Marker* _tmp11_ = NULL;
#line 427 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp11_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 427 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_g_object_unref0 (marker);
#line 427 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					marker = _tmp11_;
#line 2639 "ViewCollection.c"
				}
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp12_ = marker;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = view;
#line 429 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				marker_mark (_tmp12_, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_OBJECT, DataObject));
#line 2647 "ViewCollection.c"
			}
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2653 "ViewCollection.c"
		}
#line 421 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2657 "ViewCollection.c"
	}
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp15_ = marker;
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp15_ != NULL) {
#line 2663 "ViewCollection.c"
		Marker* _tmp16_;
		gint _tmp17_ = 0;
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp16_ = marker;
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp17_ = marker_get_count (_tmp16_);
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp14_ = _tmp17_ != 0;
#line 2672 "ViewCollection.c"
	} else {
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp14_ = FALSE;
#line 2676 "ViewCollection.c"
	}
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp18_ = _tmp14_;
#line 433 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp18_) {
#line 2682 "ViewCollection.c"
		Marker* _tmp19_;
#line 434 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp19_ = marker;
#line 434 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data_collection_remove_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp19_);
#line 2688 "ViewCollection.c"
	}
#line 418 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 2692 "ViewCollection.c"
}


static void view_collection_on_sources_altered (ViewCollection* self, DataCollection* collection, GeeMap* items) {
	GeeArrayList* to_add;
	GeeArrayList* to_remove;
	gboolean ordering_changed;
	GeeArrayList* _tmp87_;
	GeeArrayList* _tmp91_;
	gboolean _tmp95_;
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 440 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	to_add = NULL;
#line 441 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	to_remove = NULL;
#line 442 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	ordering_changed = FALSE;
#line 2715 "ViewCollection.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = items;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 2742 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			GeeMap* _tmp10_;
			DataObject* _tmp11_;
			gpointer _tmp12_ = NULL;
			Alteration* alteration;
			DataObject* _tmp13_;
			DataSource* _tmp14_;
			DataSource* source;
			ViewCollectionMonitorImpl* monitor;
			gboolean ignored;
			gboolean _tmp39_;
			gboolean _tmp41_ = FALSE;
			ViewCollectionMonitorImpl* _tmp42_;
			gboolean _tmp45_;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 2769 "ViewCollection.c"
			}
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 444 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = items;
#line 444 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = object;
#line 444 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 444 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			alteration = (Alteration*) _tmp12_;
#line 445 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = object;
#line 445 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_SOURCE, DataSource));
#line 445 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			source = _tmp14_;
#line 447 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			monitor = NULL;
#line 448 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			ignored = TRUE;
#line 2795 "ViewCollection.c"
			{
				GeeHashMultiMap* _tmp15_;
				DataCollection* _tmp16_;
				GeeCollection* _tmp17_ = NULL;
				GeeCollection* _tmp18_;
				GeeIterator* _tmp19_ = NULL;
				GeeIterator* _tmp20_;
				GeeIterator* _monitor_impl_it;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp15_ = self->priv->monitors;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = collection;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp17_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_MULTI_MAP, GeeMultiMap), G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_SOURCE_COLLECTION, SourceCollection));
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp18_ = _tmp17_;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable));
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp20_ = _tmp19_;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp18_);
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_monitor_impl_it = _tmp20_;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				while (TRUE) {
#line 2822 "ViewCollection.c"
					GeeIterator* _tmp21_;
					gboolean _tmp22_ = FALSE;
					GeeIterator* _tmp23_;
					gpointer _tmp24_ = NULL;
					ViewCollectionMonitorImpl* monitor_impl;
					gboolean _tmp25_ = FALSE;
					ViewCollectionMonitorImpl* _tmp26_;
					Alteration* _tmp27_;
					gboolean _tmp32_;
					ViewCollectionMonitorImpl* _tmp33_;
					ViewManager* _tmp34_;
					DataSource* _tmp35_;
					gboolean _tmp36_ = FALSE;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp21_ = _monitor_impl_it;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp22_ = gee_iterator_next (_tmp21_);
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (!_tmp22_) {
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						break;
#line 2844 "ViewCollection.c"
					}
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp23_ = _monitor_impl_it;
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp24_ = gee_iterator_get (_tmp23_);
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					monitor_impl = (ViewCollectionMonitorImpl*) _tmp24_;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp26_ = monitor_impl;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp27_ = _tmp26_->prereq;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp27_ != NULL) {
#line 2858 "ViewCollection.c"
						Alteration* _tmp28_;
						ViewCollectionMonitorImpl* _tmp29_;
						Alteration* _tmp30_;
						gboolean _tmp31_ = FALSE;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp28_ = alteration;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp29_ = monitor_impl;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp30_ = _tmp29_->prereq;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp31_ = alteration_contains_any (_tmp28_, _tmp30_);
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp25_ = !_tmp31_;
#line 2873 "ViewCollection.c"
					} else {
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp25_ = FALSE;
#line 2877 "ViewCollection.c"
					}
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp32_ = _tmp25_;
#line 450 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp32_) {
#line 451 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 451 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						continue;
#line 2887 "ViewCollection.c"
					}
#line 453 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					ignored = FALSE;
#line 455 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp33_ = monitor_impl;
#line 455 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp34_ = _tmp33_->manager;
#line 455 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp35_ = source;
#line 455 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp36_ = view_manager_include_in_view (_tmp34_, _tmp35_);
#line 455 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp36_) {
#line 2901 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp37_;
						ViewCollectionMonitorImpl* _tmp38_;
#line 456 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp37_ = monitor_impl;
#line 456 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp38_ = _view_collection_monitor_ref0 (_tmp37_);
#line 456 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 456 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						monitor = _tmp38_;
#line 458 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 458 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						break;
#line 2916 "ViewCollection.c"
					}
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor_impl);
#line 2920 "ViewCollection.c"
				}
#line 449 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_impl_it);
#line 2924 "ViewCollection.c"
			}
#line 462 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp39_ = ignored;
#line 462 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp39_) {
#line 2930 "ViewCollection.c"
				ViewCollectionMonitorImpl* _tmp40_;
#line 463 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp40_ = monitor;
#line 463 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_vala_assert (_tmp40_ == NULL, "monitor == null");
#line 465 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_view_collection_monitor_unref0 (monitor);
#line 465 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 465 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_alteration_unref0 (alteration);
#line 465 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (object);
#line 465 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				continue;
#line 2946 "ViewCollection.c"
			}
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp42_ = monitor;
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp42_ != NULL) {
#line 2952 "ViewCollection.c"
				DataSource* _tmp43_;
				gboolean _tmp44_ = FALSE;
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp43_ = source;
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp44_ = view_collection_has_view_for_source (self, _tmp43_);
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp41_ = !_tmp44_;
#line 2961 "ViewCollection.c"
			} else {
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp41_ = FALSE;
#line 2965 "ViewCollection.c"
			}
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp45_ = _tmp41_;
#line 468 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp45_) {
#line 2971 "ViewCollection.c"
				GeeArrayList* _tmp46_;
				GeeArrayList* _tmp48_;
				ViewCollectionMonitorImpl* _tmp49_;
				ViewManager* _tmp50_;
				DataSource* _tmp51_;
				DataView* _tmp52_ = NULL;
				DataView* _tmp53_;
#line 469 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp46_ = to_add;
#line 469 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp46_ == NULL) {
#line 2983 "ViewCollection.c"
					GeeArrayList* _tmp47_;
#line 470 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp47_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 470 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_g_object_unref0 (to_add);
#line 470 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					to_add = _tmp47_;
#line 2991 "ViewCollection.c"
				}
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp48_ = to_add;
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp49_ = monitor;
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp50_ = _tmp49_->manager;
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp51_ = source;
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp52_ = view_manager_create_view (_tmp50_, _tmp51_);
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp53_ = _tmp52_;
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp53_);
#line 472 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp53_);
#line 3009 "ViewCollection.c"
			} else {
				gboolean _tmp54_ = FALSE;
				ViewCollectionMonitorImpl* _tmp55_;
				gboolean _tmp58_;
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp55_ = monitor;
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp55_ == NULL) {
#line 3018 "ViewCollection.c"
					DataSource* _tmp56_;
					gboolean _tmp57_ = FALSE;
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp56_ = source;
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp57_ = view_collection_has_view_for_source (self, _tmp56_);
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp54_ = _tmp57_;
#line 3027 "ViewCollection.c"
				} else {
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp54_ = FALSE;
#line 3031 "ViewCollection.c"
				}
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp58_ = _tmp54_;
#line 473 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp58_) {
#line 3037 "ViewCollection.c"
					GeeArrayList* _tmp59_;
					GeeArrayList* _tmp61_;
					DataSource* _tmp62_;
					DataView* _tmp63_ = NULL;
					DataView* _tmp64_;
#line 474 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp59_ = to_remove;
#line 474 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp59_ == NULL) {
#line 3047 "ViewCollection.c"
						GeeArrayList* _tmp60_;
#line 475 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp60_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 475 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_g_object_unref0 (to_remove);
#line 475 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						to_remove = _tmp60_;
#line 3055 "ViewCollection.c"
					}
#line 477 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp61_ = to_remove;
#line 477 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp62_ = source;
#line 477 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp63_ = view_collection_get_view_for_source (self, _tmp62_);
#line 477 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp64_ = _tmp63_;
#line 477 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp64_);
#line 477 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_g_object_unref0 (_tmp64_);
#line 3069 "ViewCollection.c"
				} else {
					gboolean _tmp65_ = FALSE;
					ViewCollectionMonitorImpl* _tmp66_;
					gboolean _tmp69_;
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp66_ = monitor;
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp66_ != NULL) {
#line 3078 "ViewCollection.c"
						DataSource* _tmp67_;
						gboolean _tmp68_ = FALSE;
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp67_ = source;
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp68_ = view_collection_has_view_for_source (self, _tmp67_);
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp65_ = _tmp68_;
#line 3087 "ViewCollection.c"
					} else {
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp65_ = FALSE;
#line 3091 "ViewCollection.c"
					}
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp69_ = _tmp65_;
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp69_) {
#line 3097 "ViewCollection.c"
						DataSource* _tmp70_;
						DataView* _tmp71_ = NULL;
						DataView* view;
						DataSet* _tmp72_;
						DataView* _tmp73_;
						gboolean _tmp74_ = FALSE;
						gboolean _tmp78_ = FALSE;
						DataSet* _tmp79_;
						gboolean _tmp82_;
#line 479 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp70_ = source;
#line 479 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp71_ = view_collection_get_view_for_source (self, _tmp70_);
#line 479 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						view = _tmp71_;
#line 481 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp72_ = self->priv->selected;
#line 481 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp73_ = view;
#line 481 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp74_ = data_set_contains (_tmp72_, G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, TYPE_DATA_OBJECT, DataObject));
#line 481 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						if (_tmp74_) {
#line 3121 "ViewCollection.c"
							DataSet* _tmp75_;
							DataView* _tmp76_;
							Alteration* _tmp77_;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp75_ = self->priv->selected;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp76_ = view;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp77_ = alteration;
#line 482 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							data_set_resort_object (_tmp75_, G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, TYPE_DATA_OBJECT, DataObject), _tmp77_);
#line 3133 "ViewCollection.c"
						}
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp79_ = self->priv->visible;
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						if (_tmp79_ != NULL) {
#line 3139 "ViewCollection.c"
							DataView* _tmp80_;
							gboolean _tmp81_ = FALSE;
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp80_ = view;
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp81_ = view_collection_is_visible (self, _tmp80_);
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp78_ = _tmp81_;
#line 3148 "ViewCollection.c"
						} else {
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp78_ = FALSE;
#line 3152 "ViewCollection.c"
						}
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp82_ = _tmp78_;
#line 484 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						if (_tmp82_) {
#line 3158 "ViewCollection.c"
							DataSet* _tmp83_;
							DataView* _tmp84_;
							Alteration* _tmp85_;
							gboolean _tmp86_ = FALSE;
#line 485 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp83_ = self->priv->visible;
#line 485 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp84_ = view;
#line 485 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp85_ = alteration;
#line 485 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp86_ = data_set_resort_object (_tmp83_, G_TYPE_CHECK_INSTANCE_CAST (_tmp84_, TYPE_DATA_OBJECT, DataObject), _tmp85_);
#line 485 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							if (_tmp86_) {
#line 486 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
								ordering_changed = TRUE;
#line 3175 "ViewCollection.c"
							}
						}
#line 478 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_g_object_unref0 (view);
#line 3180 "ViewCollection.c"
					}
				}
			}
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_view_collection_monitor_unref0 (monitor);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_alteration_unref0 (alteration);
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3192 "ViewCollection.c"
		}
#line 443 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3196 "ViewCollection.c"
	}
#line 491 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp87_ = to_add;
#line 491 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp87_ != NULL) {
#line 3202 "ViewCollection.c"
		GeeArrayList* _tmp88_;
		GeeCollection* _tmp89_ = NULL;
		GeeCollection* _tmp90_;
#line 492 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp88_ = to_add;
#line 492 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp89_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 492 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp90_ = _tmp89_;
#line 492 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp90_);
#line 3214 "ViewCollection.c"
	}
#line 494 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp91_ = to_remove;
#line 494 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp91_ != NULL) {
#line 3220 "ViewCollection.c"
		GeeArrayList* _tmp92_;
		Marker* _tmp93_ = NULL;
		Marker* _tmp94_;
#line 495 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp92_ = to_remove;
#line 495 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp93_ = data_collection_mark_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp92_, GEE_TYPE_COLLECTION, GeeCollection));
#line 495 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp94_ = _tmp93_;
#line 495 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data_collection_remove_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp94_);
#line 495 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp94_);
#line 3234 "ViewCollection.c"
	}
#line 497 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp95_ = ordering_changed;
#line 497 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp95_) {
#line 498 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data_collection_notify_ordering_changed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 3242 "ViewCollection.c"
	}
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (to_remove);
#line 437 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3248 "ViewCollection.c"
}


static void view_collection_on_mirror_contents_added (ViewCollection* self, GeeIterable* added) {
	GeeArrayList* _tmp0_;
	GeeArrayList* to_add;
	GeeArrayList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
#line 501 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 501 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 502 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 502 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	to_add = _tmp0_;
#line 3266 "ViewCollection.c"
	{
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _object_it;
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = added;
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp2_;
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3279 "ViewCollection.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataObject* _tmp7_;
			DataSource* _tmp8_ = NULL;
			DataSource* source;
			gboolean _tmp9_ = FALSE;
			CreateViewPredicate _tmp10_;
			void* _tmp10__target;
			gboolean _tmp14_;
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp4_) {
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 3300 "ViewCollection.c"
			}
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 504 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 504 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 504 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			source = _tmp8_;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = self->priv->should_mirror;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10__target = self->priv->should_mirror_target;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp10_ == NULL) {
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp9_ = TRUE;
#line 3322 "ViewCollection.c"
			} else {
				CreateViewPredicate _tmp11_;
				void* _tmp11__target;
				DataSource* _tmp12_;
				gboolean _tmp13_ = FALSE;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp11_ = self->priv->should_mirror;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp11__target = self->priv->should_mirror_target;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp12_ = source;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = _tmp11_ (_tmp12_, _tmp11__target);
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp9_ = _tmp13_;
#line 3338 "ViewCollection.c"
			}
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = _tmp9_;
#line 506 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp14_) {
#line 3344 "ViewCollection.c"
				GeeArrayList* _tmp15_;
				CreateView _tmp16_;
				void* _tmp16__target;
				DataSource* _tmp17_;
				DataView* _tmp18_ = NULL;
				DataView* _tmp19_;
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp15_ = to_add;
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = self->priv->mirroring_ctor;
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16__target = self->priv->mirroring_ctor_target;
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp17_ = source;
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp18_ = _tmp16_ (_tmp17_, _tmp16__target);
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = _tmp18_;
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 507 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp19_);
#line 3367 "ViewCollection.c"
			}
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3373 "ViewCollection.c"
		}
#line 503 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3377 "ViewCollection.c"
	}
#line 510 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp20_ = to_add;
#line 510 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp21_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_COLLECTION, GeeCollection));
#line 510 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp22_ = _tmp21_;
#line 510 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp22_ > 0) {
#line 3387 "ViewCollection.c"
		GeeArrayList* _tmp23_;
		GeeCollection* _tmp24_ = NULL;
		GeeCollection* _tmp25_;
#line 511 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp23_ = to_add;
#line 511 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp24_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 511 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp25_ = _tmp24_;
#line 511 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp25_);
#line 3399 "ViewCollection.c"
	}
#line 501 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3403 "ViewCollection.c"
}


static void view_collection_on_mirror_contents_removed (ViewCollection* self, GeeIterable* removed) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
	Marker* _tmp17_;
#line 514 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 514 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 515 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 515 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 3419 "ViewCollection.c"
	{
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _object_it;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = removed;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp2_;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3432 "ViewCollection.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			DataObject* object;
			DataObject* _tmp7_;
			DataView* _tmp8_;
			DataView* view;
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			DataView* _tmp12_ = NULL;
			DataView* _tmp13_;
			DataView* our_view;
			DataView* _tmp14_;
			Marker* _tmp15_;
			DataView* _tmp16_;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp4_) {
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 3458 "ViewCollection.c"
			}
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 517 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = _tmp8_;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = view_collection_get_view_for_source (self, _tmp11_);
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = _tmp12_;
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 519 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			our_view = _tmp13_;
#line 520 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = our_view;
#line 520 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_vala_assert (_tmp14_ != NULL, "our_view != null");
#line 522 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = marker;
#line 522 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp16_ = our_view;
#line 522 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			marker_mark (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_DATA_OBJECT, DataObject));
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (our_view);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3502 "ViewCollection.c"
		}
#line 516 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3506 "ViewCollection.c"
	}
#line 525 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp17_ = marker;
#line 525 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_remove_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp17_);
#line 514 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 3514 "ViewCollection.c"
}


static void view_collection_real_notify_items_added (DataCollection* base, GeeIterable* added) {
	ViewCollection * self;
	GeeArrayList* added_visible;
	GeeArrayList* added_selected;
	GeeArrayList* _tmp32_;
	GeeArrayList* _tmp36_;
	GeeIterable* _tmp39_;
#line 529 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 529 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (added));
#line 530 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	added_visible = NULL;
#line 531 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	added_selected = NULL;
#line 3533 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = added;
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3546 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			DataObject* _tmp6_;
			DataView* _tmp7_;
			DataView* view;
			GeeHashMap* _tmp8_;
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			DataView* _tmp12_;
			gboolean _tmp13_ = FALSE;
			DataView* _tmp14_;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp18_;
			gboolean _tmp23_ = FALSE;
			DataView* _tmp24_;
			gboolean _tmp25_ = FALSE;
			gboolean _tmp27_;
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 3576 "ViewCollection.c"
			}
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp5_;
#line 534 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = object;
#line 534 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_VIEW, DataView));
#line 534 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = _tmp7_;
#line 535 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = self->priv->source_map;
#line 535 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 535 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 535 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 535 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = view;
#line 535 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_, _tmp12_);
#line 535 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = view;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = data_view_is_selected (_tmp14_);
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 3610 "ViewCollection.c"
				DataView* _tmp16_;
				gboolean _tmp17_ = FALSE;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = view;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp17_ = data_view_is_visible (_tmp16_);
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = _tmp17_;
#line 3619 "ViewCollection.c"
			} else {
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = FALSE;
#line 3623 "ViewCollection.c"
			}
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp18_ = _tmp13_;
#line 537 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp18_) {
#line 3629 "ViewCollection.c"
				GeeArrayList* _tmp19_;
				GeeArrayList* _tmp21_;
				DataView* _tmp22_;
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = added_selected;
#line 538 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp19_ == NULL) {
#line 3637 "ViewCollection.c"
					GeeArrayList* _tmp20_;
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp20_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_g_object_unref0 (added_selected);
#line 539 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					added_selected = _tmp20_;
#line 3645 "ViewCollection.c"
				}
#line 541 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp21_ = added_selected;
#line 541 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp22_ = view;
#line 541 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp22_);
#line 3653 "ViewCollection.c"
			}
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp24_ = view;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp25_ = data_view_is_visible (_tmp24_);
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp25_) {
#line 3661 "ViewCollection.c"
				DataSet* _tmp26_;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp26_ = self->priv->visible;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp23_ = _tmp26_ != NULL;
#line 3667 "ViewCollection.c"
			} else {
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp23_ = FALSE;
#line 3671 "ViewCollection.c"
			}
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp27_ = _tmp23_;
#line 545 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp27_) {
#line 3677 "ViewCollection.c"
				GeeArrayList* _tmp28_;
				GeeArrayList* _tmp30_;
				DataView* _tmp31_;
#line 546 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp28_ = added_visible;
#line 546 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp28_ == NULL) {
#line 3685 "ViewCollection.c"
					GeeArrayList* _tmp29_;
#line 547 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp29_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 547 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_g_object_unref0 (added_visible);
#line 547 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					added_visible = _tmp29_;
#line 3693 "ViewCollection.c"
				}
#line 549 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp30_ = added_visible;
#line 549 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp31_ = view;
#line 549 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp31_);
#line 3701 "ViewCollection.c"
			}
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3707 "ViewCollection.c"
		}
#line 533 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3711 "ViewCollection.c"
	}
#line 553 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp32_ = added_visible;
#line 553 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp32_ != NULL) {
#line 3717 "ViewCollection.c"
		GeeArrayList* _tmp33_;
		gboolean _tmp34_ = FALSE;
		gboolean is_added;
		gboolean _tmp35_;
#line 554 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp33_ = added_visible;
#line 554 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp34_ = view_collection_add_many_visible (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_COLLECTION, GeeCollection));
#line 554 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		is_added = _tmp34_;
#line 555 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp35_ = is_added;
#line 555 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_vala_assert (_tmp35_, "is_added");
#line 3732 "ViewCollection.c"
	}
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp36_ = added_selected;
#line 558 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp36_ != NULL) {
#line 3738 "ViewCollection.c"
		GeeArrayList* _tmp37_;
		GeeArrayList* _tmp38_;
#line 559 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp37_ = added_selected;
#line 559 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_COLLECTION, GeeCollection));
#line 560 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp38_ = added_selected;
#line 560 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_COLLECTION, GeeCollection), NULL);
#line 3749 "ViewCollection.c"
	}
#line 563 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp39_ = added;
#line 563 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp39_);
#line 529 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 529 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (added_visible);
#line 3759 "ViewCollection.c"
}


static void view_collection_real_notify_items_removed (DataCollection* base, GeeIterable* removed) {
	ViewCollection * self;
	GeeArrayList* selected_removed;
	GeeArrayList* _tmp43_;
	GeeIterable* _tmp45_;
#line 567 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 567 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (removed));
#line 568 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	selected_removed = NULL;
#line 3774 "ViewCollection.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _object_it;
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = removed;
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 3787 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataObject* object;
			DataObject* _tmp6_;
			DataView* _tmp7_;
			DataView* view;
			GeeHashMap* _tmp8_;
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 3810 "ViewCollection.c"
			}
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp5_;
#line 570 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = object;
#line 570 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_VIEW, DataView));
#line 570 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = _tmp7_;
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = self->priv->source_map;
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp11_);
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = _tmp12_;
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 576 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp13_) {
#line 3840 "ViewCollection.c"
				GeeHashMap* _tmp14_;
				DataView* _tmp15_;
				DataSource* _tmp16_ = NULL;
				DataSource* _tmp17_;
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_;
				gboolean is_removed;
				gboolean _tmp20_;
				DataView* _tmp21_;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp34_ = FALSE;
				DataView* _tmp35_;
				gboolean _tmp36_ = FALSE;
				gboolean _tmp38_;
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp14_ = self->priv->source_map;
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp15_ = view;
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = data_view_get_source (_tmp15_);
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp17_ = _tmp16_;
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp18_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp17_, NULL);
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = _tmp18_;
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp17_);
#line 577 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				is_removed = _tmp19_;
#line 578 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp20_ = is_removed;
#line 578 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_vala_assert (_tmp20_, "is_removed");
#line 580 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp21_ = view;
#line 580 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp22_ = data_view_is_selected (_tmp21_);
#line 580 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp22_) {
#line 3881 "ViewCollection.c"
					DataSet* _tmp23_;
					DataView* _tmp24_;
					gboolean _tmp25_ = FALSE;
					DataView* _tmp26_;
					gboolean _tmp27_ = FALSE;
					DataView* _tmp28_;
					gboolean _tmp29_ = FALSE;
#line 582 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp23_ = self->priv->selected;
#line 582 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp24_ = view;
#line 582 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp25_ = data_set_contains (_tmp23_, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_DATA_OBJECT, DataObject));
#line 582 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp26_ = view;
#line 582 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp27_ = data_view_is_visible (_tmp26_);
#line 582 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_vala_assert (_tmp25_ == _tmp27_, "selected.contains(view) == view.is_visible()");
#line 584 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp28_ = view;
#line 584 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp29_ = data_view_is_visible (_tmp28_);
#line 584 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp29_) {
#line 3907 "ViewCollection.c"
						GeeArrayList* _tmp30_;
						GeeArrayList* _tmp32_;
						DataView* _tmp33_;
#line 585 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp30_ = selected_removed;
#line 585 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						if (_tmp30_ == NULL) {
#line 3915 "ViewCollection.c"
							GeeArrayList* _tmp31_;
#line 586 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_tmp31_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 586 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							_g_object_unref0 (selected_removed);
#line 586 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
							selected_removed = _tmp31_;
#line 3923 "ViewCollection.c"
						}
#line 588 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp32_ = selected_removed;
#line 588 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp33_ = view;
#line 588 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp33_);
#line 3931 "ViewCollection.c"
					}
				}
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp35_ = view;
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp36_ = data_view_is_visible (_tmp35_);
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp36_) {
#line 3940 "ViewCollection.c"
					DataSet* _tmp37_;
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp37_ = self->priv->visible;
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp34_ = _tmp37_ != NULL;
#line 3946 "ViewCollection.c"
				} else {
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp34_ = FALSE;
#line 3950 "ViewCollection.c"
				}
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp38_ = _tmp34_;
#line 592 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp38_) {
#line 3956 "ViewCollection.c"
					DataSet* _tmp39_;
					DataView* _tmp40_;
					gboolean _tmp41_ = FALSE;
					gboolean _tmp42_;
#line 593 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp39_ = self->priv->visible;
#line 593 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp40_ = view;
#line 593 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp41_ = data_set_remove (_tmp39_, G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_OBJECT, DataObject));
#line 593 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					is_removed = _tmp41_;
#line 594 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp42_ = is_removed;
#line 594 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_vala_assert (_tmp42_, "is_removed");
#line 3973 "ViewCollection.c"
				}
			}
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3980 "ViewCollection.c"
		}
#line 569 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3984 "ViewCollection.c"
	}
#line 599 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp43_ = selected_removed;
#line 599 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp43_ != NULL) {
#line 3990 "ViewCollection.c"
		GeeArrayList* _tmp44_;
#line 600 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp44_ = selected_removed;
#line 600 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, GEE_TYPE_COLLECTION, GeeCollection));
#line 605 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 3998 "ViewCollection.c"
	}
#line 608 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp45_ = removed;
#line 608 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp45_);
#line 567 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (selected_removed);
#line 4006 "ViewCollection.c"
}


static void view_collection_filter_altered_items (ViewCollection* self, GeeCollection* views) {
	GeeArrayList* to_show;
	GeeArrayList* to_hide;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp22_;
#line 611 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 611 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 614 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	to_show = NULL;
#line 615 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	to_hide = NULL;
#line 4023 "ViewCollection.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _view_it;
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = views;
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_view_it = _tmp1_;
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 4036 "ViewCollection.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataView* view;
			DataView* _tmp6_;
			gboolean _tmp7_ = FALSE;
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = _view_it;
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp3_) {
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 4052 "ViewCollection.c"
			}
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _view_it;
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = (DataView*) _tmp5_;
#line 621 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 621 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = view_collection_is_in_filter (self, _tmp6_);
#line 621 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp7_) {
#line 4066 "ViewCollection.c"
				DataView* _tmp8_;
				gboolean _tmp9_ = FALSE;
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp8_ = view;
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp9_ = data_view_is_visible (_tmp8_);
#line 622 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!_tmp9_) {
#line 4075 "ViewCollection.c"
					GeeArrayList* _tmp10_;
					GeeArrayList* _tmp12_;
					DataView* _tmp13_;
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp10_ = to_show;
#line 623 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp10_ == NULL) {
#line 4083 "ViewCollection.c"
						GeeArrayList* _tmp11_;
#line 624 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp11_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 624 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_g_object_unref0 (to_show);
#line 624 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						to_show = _tmp11_;
#line 4091 "ViewCollection.c"
					}
#line 626 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp12_ = to_show;
#line 626 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp13_ = view;
#line 626 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp13_);
#line 4099 "ViewCollection.c"
				}
			} else {
				DataView* _tmp14_;
				gboolean _tmp15_ = FALSE;
#line 629 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 629 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp15_ = data_view_is_visible (_tmp14_);
#line 629 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp15_) {
#line 4110 "ViewCollection.c"
					GeeArrayList* _tmp16_;
					GeeArrayList* _tmp18_;
					DataView* _tmp19_;
#line 630 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp16_ = to_hide;
#line 630 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					if (_tmp16_ == NULL) {
#line 4118 "ViewCollection.c"
						GeeArrayList* _tmp17_;
#line 631 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_tmp17_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 631 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						_g_object_unref0 (to_hide);
#line 631 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
						to_hide = _tmp17_;
#line 4126 "ViewCollection.c"
					}
#line 633 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp18_ = to_hide;
#line 633 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp19_ = view;
#line 633 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp19_);
#line 4134 "ViewCollection.c"
				}
			}
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 4139 "ViewCollection.c"
		}
#line 620 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 4143 "ViewCollection.c"
	}
#line 642 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp20_ = to_show;
#line 642 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp20_ != NULL) {
#line 4149 "ViewCollection.c"
		GeeArrayList* _tmp21_;
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp21_ = to_show;
#line 643 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_show_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_LIST, GeeList));
#line 4155 "ViewCollection.c"
	}
#line 645 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp22_ = to_hide;
#line 645 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp22_ != NULL) {
#line 4161 "ViewCollection.c"
		GeeArrayList* _tmp23_;
#line 646 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp23_ = to_hide;
#line 646 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_hide_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_LIST, GeeList));
#line 4167 "ViewCollection.c"
	}
#line 611 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (to_hide);
#line 611 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (to_show);
#line 4173 "ViewCollection.c"
}


static void view_collection_real_items_altered (DataCollection* base, GeeMap* map) {
	ViewCollection * self;
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeMap* _tmp4_;
#line 649 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 649 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 650 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = map;
#line 650 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = gee_map_get_keys (_tmp0_);
#line 650 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 650 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 650 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 650 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp3_);
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = map;
#line 652 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp4_);
#line 4204 "ViewCollection.c"
}


static void view_collection_real_set_comparator (DataCollection* base, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target) {
	ViewCollection * self;
	DataSet* _tmp0_;
	Comparator _tmp1_;
	void* _tmp1__target;
	ComparatorPredicate _tmp2_;
	void* _tmp2__target;
	DataSet* _tmp3_;
	Comparator _tmp7_;
	void* _tmp7__target;
	ComparatorPredicate _tmp8_;
	void* _tmp8__target;
#line 655 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 656 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 656 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = comparator;
#line 656 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1__target = comparator_target;
#line 656 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = predicate;
#line 656 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2__target = predicate_target;
#line 656 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_set_set_comparator (_tmp0_, _tmp1_, _tmp1__target, _tmp2_, _tmp2__target);
#line 657 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = self->priv->visible;
#line 657 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 4238 "ViewCollection.c"
		DataSet* _tmp4_;
		Comparator _tmp5_;
		void* _tmp5__target;
		ComparatorPredicate _tmp6_;
		void* _tmp6__target;
#line 658 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->visible;
#line 658 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = comparator;
#line 658 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5__target = comparator_target;
#line 658 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = predicate;
#line 658 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6__target = predicate_target;
#line 658 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data_set_set_comparator (_tmp4_, _tmp5_, _tmp5__target, _tmp6_, _tmp6__target);
#line 4256 "ViewCollection.c"
	}
#line 660 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = comparator;
#line 660 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7__target = comparator_target;
#line 660 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = predicate;
#line 660 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8__target = predicate_target;
#line 660 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp7_, _tmp7__target, _tmp8_, _tmp8__target);
#line 4268 "ViewCollection.c"
}


static void view_collection_real_reset_comparator (DataCollection* base) {
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 663 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 664 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 664 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_set_reset_comparator (_tmp0_);
#line 665 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 665 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4286 "ViewCollection.c"
		DataSet* _tmp2_;
#line 666 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 666 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data_set_reset_comparator (_tmp2_);
#line 4292 "ViewCollection.c"
	}
#line 668 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 4296 "ViewCollection.c"
}


static GeeCollection* view_collection_real_get_all (DataCollection* base) {
	ViewCollection * self;
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	DataSet* _tmp1_;
#line 671 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4311 "ViewCollection.c"
		DataSet* _tmp2_;
		GeeList* _tmp3_ = NULL;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_all (_tmp2_);
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 4322 "ViewCollection.c"
	} else {
		GeeCollection* _tmp4_ = NULL;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4331 "ViewCollection.c"
	}
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 672 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4337 "ViewCollection.c"
}


GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
#line 675 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 676 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 676 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 676 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4352 "ViewCollection.c"
}


static gint view_collection_real_get_count (DataCollection* base) {
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
#line 679 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4367 "ViewCollection.c"
		DataSet* _tmp2_;
		gint _tmp3_ = 0;
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_count (_tmp2_);
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp3_;
#line 4376 "ViewCollection.c"
	} else {
		gint _tmp4_ = 0;
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4383 "ViewCollection.c"
	}
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 680 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4389 "ViewCollection.c"
}


gint view_collection_get_unfiltered_count (ViewCollection* self) {
	gint result = 0;
	gint _tmp0_ = 0;
#line 683 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 684 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 684 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 684 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4404 "ViewCollection.c"
}


static DataObject* view_collection_real_get_at (DataCollection* base, gint index) {
	ViewCollection * self;
	DataObject* result = NULL;
	DataObject* _tmp0_ = NULL;
	DataSet* _tmp1_;
#line 687 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4419 "ViewCollection.c"
		DataSet* _tmp2_;
		gint _tmp3_;
		DataObject* _tmp4_ = NULL;
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = index;
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = data_set_get_at (_tmp2_, _tmp3_);
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4433 "ViewCollection.c"
	} else {
		gint _tmp5_;
		DataObject* _tmp6_ = NULL;
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = index;
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp5_);
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp6_;
#line 4445 "ViewCollection.c"
	}
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 688 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4451 "ViewCollection.c"
}


static gint view_collection_real_index_of (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gint result = 0;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
#line 691 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 691 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4468 "ViewCollection.c"
		DataSet* _tmp2_;
		DataObject* _tmp3_;
		gint _tmp4_ = 0;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = object;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = data_set_index_of (_tmp2_, _tmp3_);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4480 "ViewCollection.c"
	} else {
		DataObject* _tmp5_;
		gint _tmp6_ = 0;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = object;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp5_);
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp6_;
#line 4490 "ViewCollection.c"
	}
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 692 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4496 "ViewCollection.c"
}


static gboolean view_collection_real_contains (DataCollection* base, DataObject* object) {
	ViewCollection * self;
	gboolean result = FALSE;
	DataObject* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DataObject* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 695 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 695 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 698 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 698 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp0_);
#line 698 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp1_) {
#line 699 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = FALSE;
#line 699 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 4521 "ViewCollection.c"
	}
#line 702 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = object;
#line 702 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = view_collection_is_visible (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_VIEW, DataView));
#line 702 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 702 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4531 "ViewCollection.c"
}


static DataView* view_collection_real_get_first (ViewCollection* self) {
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ > 0) {
#line 4543 "ViewCollection.c"
		DataObject* _tmp2_ = NULL;
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), 0);
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_VIEW, DataView);
#line 4551 "ViewCollection.c"
	} else {
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4557 "ViewCollection.c"
	}
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 706 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4563 "ViewCollection.c"
}


DataView* view_collection_get_first (ViewCollection* self) {
#line 705 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 705 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first (self);
#line 4572 "ViewCollection.c"
}


/**
     * @brief A helper method for places in the app that need a
     *  non-rejected media source (namely Events, when looking to
     *  automatically choose a thumbnail).
     *
     * @note If every view in this collection is rejected, we
     *  return the first view; this is intentional.  This prevents
     *  pathological events that have nothing but rejected images
     *  in them from breaking.
     */
static DataView* view_collection_real_get_first_unrejected (ViewCollection* self) {
	DataView* result = NULL;
	gint _tmp0_ = 0;
	DataView* _tmp1_ = NULL;
	DataView* dv;
	gint _tmp2_ = 0;
	gint num_views;
	DataView* _tmp19_ = NULL;
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 721 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp0_ < 1) {
#line 722 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = NULL;
#line 722 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 4602 "ViewCollection.c"
	}
#line 725 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_first (self);
#line 725 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	dv = _tmp1_;
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 726 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	num_views = _tmp2_;
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	while (TRUE) {
#line 4614 "ViewCollection.c"
		gboolean _tmp3_ = FALSE;
		DataView* _tmp4_;
		gboolean _tmp8_;
		DataView* _tmp9_;
		DataSource* _tmp10_ = NULL;
		MediaSource* _tmp11_;
		MediaSource* tmp;
		gboolean _tmp12_ = FALSE;
		MediaSource* _tmp13_;
		gboolean _tmp16_;
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = dv;
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp4_ != NULL) {
#line 4629 "ViewCollection.c"
			DataView* _tmp5_;
			gint _tmp6_ = 0;
			gint _tmp7_;
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = dv;
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_OBJECT, DataObject));
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = num_views;
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = _tmp6_ < (_tmp7_ - 1);
#line 4641 "ViewCollection.c"
		} else {
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = FALSE;
#line 4645 "ViewCollection.c"
		}
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp8_ = _tmp3_;
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (!_tmp8_) {
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			break;
#line 4653 "ViewCollection.c"
		}
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp9_ = dv;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp10_ = data_view_get_source (_tmp9_);
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, TYPE_MEDIA_SOURCE) ? ((MediaSource*) _tmp10_) : NULL;
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp11_ == NULL) {
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp10_);
#line 4665 "ViewCollection.c"
		}
#line 729 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		tmp = _tmp11_;
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp13_ = tmp;
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp13_ != NULL) {
#line 4673 "ViewCollection.c"
			MediaSource* _tmp14_;
			Rating _tmp15_ = 0;
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = tmp;
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = media_source_get_rating (_tmp14_);
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = _tmp15_ != RATING_REJECTED;
#line 4682 "ViewCollection.c"
		} else {
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = FALSE;
#line 4686 "ViewCollection.c"
		}
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp16_ = _tmp12_;
#line 731 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp16_) {
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			result = dv;
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (tmp);
#line 733 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			return result;
#line 4698 "ViewCollection.c"
		} else {
			DataView* _tmp17_;
			DataView* _tmp18_ = NULL;
#line 735 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp17_ = dv;
#line 735 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp18_ = view_collection_get_next (self, _tmp17_);
#line 735 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (dv);
#line 735 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			dv = _tmp18_;
#line 4710 "ViewCollection.c"
		}
#line 728 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (tmp);
#line 4714 "ViewCollection.c"
	}
#line 741 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp19_ = view_collection_get_first (self);
#line 741 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp19_;
#line 741 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (dv);
#line 741 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4724 "ViewCollection.c"
}


DataView* view_collection_get_first_unrejected (ViewCollection* self) {
#line 719 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 719 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_first_unrejected (self);
#line 4733 "ViewCollection.c"
}


static DataView* view_collection_real_get_last (ViewCollection* self) {
	DataView* result = NULL;
	DataView* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ > 0) {
#line 4745 "ViewCollection.c"
		gint _tmp2_ = 0;
		DataObject* _tmp3_ = NULL;
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp2_ - 1);
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_VIEW, DataView);
#line 4756 "ViewCollection.c"
	} else {
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4762 "ViewCollection.c"
	}
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 745 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4768 "ViewCollection.c"
}


DataView* view_collection_get_last (ViewCollection* self) {
#line 744 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 744 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_last (self);
#line 4777 "ViewCollection.c"
}


static DataView* view_collection_real_get_next (ViewCollection* self, DataView* view) {
	DataView* result = NULL;
	gint _tmp0_ = 0;
	DataView* _tmp1_;
	gint _tmp2_ = 0;
	gint index;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_;
	DataObject* _tmp8_ = NULL;
#line 748 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 749 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 749 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp0_ == 0) {
#line 750 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = NULL;
#line 750 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 4803 "ViewCollection.c"
	}
#line 752 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 752 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_OBJECT, DataObject));
#line 752 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	index = _tmp2_;
#line 753 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = index;
#line 753 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp3_ < 0) {
#line 754 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = NULL;
#line 754 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 4819 "ViewCollection.c"
	}
#line 756 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = index;
#line 756 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	index = _tmp4_ + 1;
#line 757 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = index;
#line 757 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 757 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp5_ >= _tmp6_) {
#line 758 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		index = 0;
#line 4833 "ViewCollection.c"
	}
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = index;
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp7_);
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView);
#line 760 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4843 "ViewCollection.c"
}


DataView* view_collection_get_next (ViewCollection* self, DataView* view) {
#line 748 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 748 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_next (self, view);
#line 4852 "ViewCollection.c"
}


static DataView* view_collection_real_get_previous (ViewCollection* self, DataView* view) {
	DataView* result = NULL;
	gint _tmp0_ = 0;
	DataView* _tmp1_;
	gint _tmp2_ = 0;
	gint index;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp7_;
	DataObject* _tmp8_ = NULL;
#line 763 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 764 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 764 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp0_ == 0) {
#line 765 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = NULL;
#line 765 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 4877 "ViewCollection.c"
	}
#line 767 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 767 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_OBJECT, DataObject));
#line 767 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	index = _tmp2_;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = index;
#line 768 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp3_ < 0) {
#line 769 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = NULL;
#line 769 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 4893 "ViewCollection.c"
	}
#line 771 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = index;
#line 771 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	index = _tmp4_ - 1;
#line 772 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = index;
#line 772 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp5_ < 0) {
#line 4903 "ViewCollection.c"
		gint _tmp6_ = 0;
#line 773 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 773 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		index = _tmp6_ - 1;
#line 4909 "ViewCollection.c"
	}
#line 775 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = index;
#line 775 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp7_);
#line 775 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView);
#line 775 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 4919 "ViewCollection.c"
}


DataView* view_collection_get_previous (ViewCollection* self, DataView* view) {
#line 763 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 763 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_COLLECTION_GET_CLASS (self)->get_previous (self, view);
#line 4928 "ViewCollection.c"
}


gboolean view_collection_get_immediate_neighbors (ViewCollection* self, DataSource* home, DataSource** next, DataSource** prev, const gchar* type_selector) {
	DataSource* _vala_next = NULL;
	DataSource* _vala_prev = NULL;
	gboolean result = FALSE;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* home_view;
	DataView* _tmp2_;
	DataView* _tmp3_;
	DataView* _tmp4_ = NULL;
	DataView* next_view;
	DataView* _tmp20_;
	DataView* _tmp21_ = NULL;
	DataView* prev_view;
#line 778 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 778 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
#line 780 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_next);
#line 780 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_next = NULL;
#line 781 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_prev);
#line 781 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_prev = NULL;
#line 783 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = home;
#line 783 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source (self, _tmp0_);
#line 783 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	home_view = _tmp1_;
#line 784 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = home_view;
#line 784 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp2_ == NULL) {
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = FALSE;
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (home_view);
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (next) {
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			*next = _vala_next;
#line 4976 "ViewCollection.c"
		} else {
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 4980 "ViewCollection.c"
		}
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (prev) {
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			*prev = _vala_prev;
#line 4986 "ViewCollection.c"
		} else {
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 4990 "ViewCollection.c"
		}
#line 785 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 4994 "ViewCollection.c"
	}
#line 787 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = home_view;
#line 787 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = view_collection_get_next (self, _tmp3_);
#line 787 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	next_view = _tmp4_;
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	while (TRUE) {
#line 5004 "ViewCollection.c"
		DataView* _tmp5_;
		DataView* _tmp6_;
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		gboolean _tmp15_;
		DataView* _tmp18_;
		DataView* _tmp19_ = NULL;
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = next_view;
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = home_view;
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (!(_tmp5_ != _tmp6_)) {
#line 788 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			break;
#line 5020 "ViewCollection.c"
		}
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp8_ = type_selector;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp8_ == NULL) {
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = TRUE;
#line 5028 "ViewCollection.c"
		} else {
			DataView* _tmp9_;
			DataSource* _tmp10_ = NULL;
			DataSource* _tmp11_;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			const gchar* _tmp14_;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = next_view;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = data_view_get_source (_tmp9_);
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = data_source_get_typename (_tmp11_);
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = _tmp12_;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = type_selector;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = g_strcmp0 (_tmp13_, _tmp14_) == 0;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_free0 (_tmp13_);
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp11_);
#line 5054 "ViewCollection.c"
		}
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp15_ = _tmp7_;
#line 789 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp15_) {
#line 5060 "ViewCollection.c"
			DataView* _tmp16_;
			DataSource* _tmp17_ = NULL;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp16_ = next_view;
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp17_ = data_view_get_source (_tmp16_);
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 790 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_vala_next = _tmp17_;
#line 791 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			break;
#line 5073 "ViewCollection.c"
		}
#line 793 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp18_ = next_view;
#line 793 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp19_ = view_collection_get_next (self, _tmp18_);
#line 793 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next_view);
#line 793 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		next_view = _tmp19_;
#line 5083 "ViewCollection.c"
	}
#line 796 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp20_ = home_view;
#line 796 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp21_ = view_collection_get_previous (self, _tmp20_);
#line 796 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	prev_view = _tmp21_;
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	while (TRUE) {
#line 5093 "ViewCollection.c"
		DataView* _tmp22_;
		DataView* _tmp23_;
		gboolean _tmp24_ = FALSE;
		const gchar* _tmp25_;
		gboolean _tmp32_;
		DataView* _tmp35_;
		DataView* _tmp36_ = NULL;
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp22_ = prev_view;
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp23_ = home_view;
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (!(_tmp22_ != _tmp23_)) {
#line 797 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			break;
#line 5109 "ViewCollection.c"
		}
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp25_ = type_selector;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp25_ == NULL) {
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp24_ = TRUE;
#line 5117 "ViewCollection.c"
		} else {
			DataView* _tmp26_;
			DataSource* _tmp27_ = NULL;
			DataSource* _tmp28_;
			gchar* _tmp29_ = NULL;
			gchar* _tmp30_;
			const gchar* _tmp31_;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp26_ = prev_view;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp27_ = data_view_get_source (_tmp26_);
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp28_ = _tmp27_;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp29_ = data_source_get_typename (_tmp28_);
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp30_ = _tmp29_;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp31_ = type_selector;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp24_ = g_strcmp0 (_tmp30_, _tmp31_) == 0;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_free0 (_tmp30_);
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp28_);
#line 5143 "ViewCollection.c"
		}
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp32_ = _tmp24_;
#line 798 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp32_) {
#line 5149 "ViewCollection.c"
			DataView* _tmp33_;
			DataSource* _tmp34_ = NULL;
#line 799 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp33_ = prev_view;
#line 799 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp34_ = data_view_get_source (_tmp33_);
#line 799 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 799 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_vala_prev = _tmp34_;
#line 800 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			break;
#line 5162 "ViewCollection.c"
		}
#line 802 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp35_ = prev_view;
#line 802 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp36_ = view_collection_get_previous (self, _tmp35_);
#line 802 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_view);
#line 802 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		prev_view = _tmp36_;
#line 5172 "ViewCollection.c"
	}
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (prev_view);
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (next_view);
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (home_view);
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (next) {
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*next = _vala_next;
#line 5186 "ViewCollection.c"
	} else {
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_next);
#line 5190 "ViewCollection.c"
	}
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (prev) {
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*prev = _vala_prev;
#line 5196 "ViewCollection.c"
	} else {
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_prev);
#line 5200 "ViewCollection.c"
	}
#line 805 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 5204 "ViewCollection.c"
}


GeeSet* view_collection_get_extended_neighbors (ViewCollection* self, DataSource* home, const gchar* typename) {
	GeeSet* result = NULL;
	GeeHashSet* _tmp0_;
	GeeSet* neighbors;
	DataSource* next = NULL;
	DataSource* prev = NULL;
	DataSource* _tmp1_;
	const gchar* _tmp2_;
	DataSource* _tmp3_ = NULL;
	DataSource* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	DataSource* _tmp6_;
	DataSource* _tmp16_;
	GeeSet* _tmp26_;
	DataSource* _tmp27_;
#line 809 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 809 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
#line 811 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 811 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	neighbors = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = home;
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = typename;
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = view_collection_get_immediate_neighbors (self, _tmp1_, &_tmp3_, &_tmp4_, _tmp2_);
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	next = _tmp3_;
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	prev = _tmp4_;
#line 815 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp5_) {
#line 816 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = neighbors;
#line 816 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (prev);
#line 816 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next);
#line 816 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 5255 "ViewCollection.c"
	}
#line 819 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = next;
#line 819 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp6_ != NULL) {
#line 5261 "ViewCollection.c"
		GeeSet* _tmp7_;
		DataSource* _tmp8_;
		DataSource* next_next = NULL;
		DataSource* next_prev = NULL;
		DataSource* _tmp9_;
		const gchar* _tmp10_;
		DataSource* _tmp11_ = NULL;
		DataSource* _tmp12_ = NULL;
		DataSource* _tmp13_;
#line 820 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = neighbors;
#line 820 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp8_ = next;
#line 820 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), _tmp8_);
#line 823 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp9_ = next;
#line 823 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp10_ = typename;
#line 823 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp9_, &_tmp11_, &_tmp12_, _tmp10_);
#line 823 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 823 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		next_next = _tmp11_;
#line 823 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 823 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		next_prev = _tmp12_;
#line 826 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp13_ = next_next;
#line 826 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp13_ != NULL) {
#line 5295 "ViewCollection.c"
			GeeSet* _tmp14_;
			DataSource* _tmp15_;
#line 827 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = neighbors;
#line 827 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = next_next;
#line 827 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_COLLECTION, GeeCollection), _tmp15_);
#line 5304 "ViewCollection.c"
		}
#line 819 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 819 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 5310 "ViewCollection.c"
	}
#line 831 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp16_ = prev;
#line 831 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp16_ != NULL) {
#line 5316 "ViewCollection.c"
		GeeSet* _tmp17_;
		DataSource* _tmp18_;
		DataSource* next_prev = NULL;
		DataSource* prev_prev = NULL;
		DataSource* _tmp19_;
		const gchar* _tmp20_;
		DataSource* _tmp21_ = NULL;
		DataSource* _tmp22_ = NULL;
		DataSource* _tmp23_;
#line 832 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp17_ = neighbors;
#line 832 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp18_ = prev;
#line 832 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection), _tmp18_);
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp19_ = prev;
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp20_ = typename;
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp19_, &_tmp21_, &_tmp22_, _tmp20_);
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		next_prev = _tmp21_;
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 835 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		prev_prev = _tmp22_;
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp23_ = prev_prev;
#line 838 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp23_ != NULL) {
#line 5350 "ViewCollection.c"
			GeeSet* _tmp24_;
			DataSource* _tmp25_;
#line 839 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp24_ = neighbors;
#line 839 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp25_ = prev_prev;
#line 839 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection), _tmp25_);
#line 5359 "ViewCollection.c"
		}
#line 831 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 831 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 5365 "ViewCollection.c"
	}
#line 843 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp26_ = neighbors;
#line 843 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp27_ = home;
#line 843 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection), _tmp27_);
#line 845 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = neighbors;
#line 845 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 845 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 845 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 5381 "ViewCollection.c"
}


static void view_collection_add_many_selected (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DataSet* _tmp11_;
	GeeCollection* _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean added;
	gboolean _tmp14_;
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 850 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 851 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp2_ == 0) {
#line 852 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return;
#line 5408 "ViewCollection.c"
	}
	{
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _view_it;
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = views;
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_view_it = _tmp4_;
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 5422 "ViewCollection.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			DataView* view;
			DataView* _tmp9_;
			gboolean _tmp10_ = FALSE;
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = _view_it;
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp6_) {
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 5438 "ViewCollection.c"
			}
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = _view_it;
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = (DataView*) _tmp8_;
#line 855 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = view;
#line 855 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = data_view_is_visible (_tmp9_);
#line 855 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_vala_assert (_tmp10_, "view.is_visible()");
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 5454 "ViewCollection.c"
		}
#line 854 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 5458 "ViewCollection.c"
	}
#line 857 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp11_ = self->priv->selected;
#line 857 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp12_ = views;
#line 857 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp13_ = data_set_add_many (_tmp11_, _tmp12_);
#line 857 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	added = _tmp13_;
#line 858 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp14_ = added;
#line 858 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (_tmp14_, "added");
#line 5472 "ViewCollection.c"
}


static void view_collection_remove_many_selected (ViewCollection* self, GeeCollection* views) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DataSet* _tmp3_;
	GeeCollection* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean removed;
	gboolean _tmp6_;
#line 861 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 861 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 862 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = views;
#line 862 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 862 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 862 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp2_ == 0) {
#line 863 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return;
#line 5499 "ViewCollection.c"
	}
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = self->priv->selected;
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = views;
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = data_set_remove_many (_tmp3_, _tmp4_);
#line 865 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	removed = _tmp5_;
#line 866 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = removed;
#line 866 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (_tmp6_, "removed");
#line 5513 "ViewCollection.c"
}


static gboolean _view_collection_select_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_select_item (self, object, user);
#line 872 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 5522 "ViewCollection.c"
}


void view_collection_select_marked (ViewCollection* self, Marker* marker) {
	GeeArrayList* _tmp0_;
	GeeArrayList* selected;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 870 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 870 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 871 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 871 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	selected = _tmp0_;
#line 872 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = marker;
#line 872 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = selected;
#line 872 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp1_, _view_collection_select_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, G_TYPE_OBJECT, GObject));
#line 874 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = selected;
#line 874 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 874 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 874 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp5_ > 0) {
#line 5556 "ViewCollection.c"
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
#line 875 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = selected;
#line 875 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 876 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = selected;
#line 876 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), NULL);
#line 5567 "ViewCollection.c"
	}
#line 870 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 5571 "ViewCollection.c"
}


void view_collection_select_all (ViewCollection* self) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
#line 881 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 882 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 882 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 883 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	marker_mark_all (marker);
#line 884 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_select_marked (self, marker);
#line 881 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5590 "ViewCollection.c"
}


static gboolean view_collection_select_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataView* _tmp1_;
	DataView* view;
	DataView* _tmp2_;
	gboolean _tmp3_ = FALSE;
	DataView* _tmp9_;
	DataView* _tmp10_;
	gboolean _tmp11_ = FALSE;
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 887 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 888 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 888 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_VIEW, DataView));
#line 888 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 889 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 889 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = data_view_is_selected (_tmp2_);
#line 889 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp3_) {
#line 5622 "ViewCollection.c"
		DataView* _tmp4_;
		gboolean _tmp5_ = FALSE;
#line 890 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = view;
#line 890 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = data_view_is_visible (_tmp4_);
#line 890 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp5_) {
#line 5631 "ViewCollection.c"
			DataSet* _tmp6_;
			DataView* _tmp7_;
			gboolean _tmp8_ = FALSE;
#line 891 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = self->priv->selected;
#line 891 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 891 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = data_set_contains (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_OBJECT, DataObject));
#line 891 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_vala_assert (_tmp8_, "selected.contains(view)");
#line 5643 "ViewCollection.c"
		}
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = TRUE;
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 893 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 5651 "ViewCollection.c"
	}
#line 896 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp9_ = view;
#line 896 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp9_, TRUE);
#line 900 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp10_ = view;
#line 900 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp11_ = data_view_is_visible (_tmp10_);
#line 900 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp11_) {
#line 5663 "ViewCollection.c"
		GObject* _tmp12_;
		DataView* _tmp13_;
#line 901 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp12_ = user;
#line 901 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp13_ = view;
#line 901 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ARRAY_LIST, GeeArrayList), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp13_);
#line 5672 "ViewCollection.c"
	}
#line 903 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 903 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 903 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 5680 "ViewCollection.c"
}


static gboolean _view_collection_unselect_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_unselect_item (self, object, user);
#line 909 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 5689 "ViewCollection.c"
}


void view_collection_unselect_marked (ViewCollection* self, Marker* marker) {
	GeeArrayList* _tmp0_;
	GeeArrayList* unselected;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 907 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 907 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 908 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 908 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 909 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = marker;
#line 909 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = unselected;
#line 909 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp1_, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, G_TYPE_OBJECT, GObject));
#line 911 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = unselected;
#line 911 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 911 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 911 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp5_ > 0) {
#line 5723 "ViewCollection.c"
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
#line 912 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = unselected;
#line 912 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 913 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = unselected;
#line 913 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 5734 "ViewCollection.c"
	}
#line 907 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5738 "ViewCollection.c"
}


void view_collection_unselect_all (ViewCollection* self) {
	DataSet* _tmp0_;
	gint _tmp1_ = 0;
	Marker* _tmp2_ = NULL;
	Marker* marker;
	Marker* _tmp3_;
	GeeList* _tmp4_ = NULL;
	GeeList* _tmp5_;
	Marker* _tmp6_;
#line 918 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_count (_tmp0_);
#line 919 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 920 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return;
#line 5761 "ViewCollection.c"
	}
#line 922 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 922 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	marker = _tmp2_;
#line 923 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = marker;
#line 923 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = view_collection_get_selected (self);
#line 923 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 923 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	marker_mark_many (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 923 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp5_);
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = marker;
#line 925 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp6_);
#line 918 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5783 "ViewCollection.c"
}


void view_collection_unselect_all_but (ViewCollection* self, DataView* exception) {
	Marker* _tmp0_ = NULL;
	Marker* marker;
	Marker* _tmp15_;
#line 929 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 929 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (exception));
#line 930 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 930 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 5799 "ViewCollection.c"
	{
		GeeCollection* _tmp1_ = NULL;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _tmp4_;
		GeeIterator* _object_it;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 5820 "ViewCollection.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			DataObject* object;
			DataObject* _tmp9_;
			DataView* _tmp10_;
			DataView* view;
			DataView* _tmp11_;
			DataView* _tmp12_;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp6_) {
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 5839 "ViewCollection.c"
			}
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = _object_it;
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp8_;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = object;
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_DATA_VIEW, DataView));
#line 932 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = _tmp10_;
#line 933 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = view;
#line 933 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = exception;
#line 933 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp11_ != _tmp12_) {
#line 5859 "ViewCollection.c"
				Marker* _tmp13_;
				DataView* _tmp14_;
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = marker;
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 934 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				marker_mark (_tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_DATA_OBJECT, DataObject));
#line 5868 "ViewCollection.c"
			}
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 5874 "ViewCollection.c"
		}
#line 931 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 5878 "ViewCollection.c"
	}
#line 937 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp15_ = marker;
#line 937 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp15_);
#line 929 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5886 "ViewCollection.c"
}


static gboolean view_collection_unselect_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataView* _tmp1_;
	DataView* view;
	DataView* _tmp2_;
	gboolean _tmp3_ = FALSE;
	DataView* _tmp7_;
	GObject* _tmp8_;
	DataView* _tmp9_;
#line 940 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 940 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 940 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 941 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 941 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_VIEW, DataView));
#line 941 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 942 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 942 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = data_view_is_selected (_tmp2_);
#line 942 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp3_) {
#line 5918 "ViewCollection.c"
		DataSet* _tmp4_;
		DataView* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 943 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = self->priv->selected;
#line 943 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = view;
#line 943 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = data_set_contains (_tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_OBJECT, DataObject));
#line 943 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_vala_assert (!_tmp6_, "!selected.contains(view)");
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = TRUE;
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 945 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 5936 "ViewCollection.c"
	}
#line 948 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = view;
#line 948 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp7_, FALSE);
#line 949 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = user;
#line 949 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp9_ = view;
#line 949 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ARRAY_LIST, GeeArrayList), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp9_);
#line 951 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 951 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 951 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 5954 "ViewCollection.c"
}


void view_collection_unselect_and_select_marked (ViewCollection* self, Marker* unselect, Marker* select) {
	GeeArrayList* _tmp0_;
	GeeArrayList* unselected;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* selected;
	Marker* _tmp3_;
#line 955 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 955 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (unselect));
#line 955 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (select));
#line 956 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 956 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 957 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = unselect;
#line 957 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp1_, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (unselected, G_TYPE_OBJECT, GObject));
#line 959 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (unselected, GEE_TYPE_COLLECTION, GeeCollection));
#line 961 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 961 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	selected = _tmp2_;
#line 962 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = select;
#line 962 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp3_, _view_collection_select_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (selected, G_TYPE_OBJECT, GObject));
#line 964 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection));
#line 966 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (unselected, GEE_TYPE_COLLECTION, GeeCollection));
#line 955 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 955 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 5997 "ViewCollection.c"
}


static gboolean _view_collection_toggle_item_marked_action (DataObject* object, GObject* user, gpointer self) {
	gboolean result;
	result = view_collection_toggle_item (self, object, user);
#line 973 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6006 "ViewCollection.c"
}


void view_collection_toggle_marked (ViewCollection* self, Marker* marker) {
	ViewCollectionToggleLists* _tmp0_;
	ViewCollectionToggleLists* lists;
	Marker* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
#line 971 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 971 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 972 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = view_collection_toggle_lists_new ();
#line 972 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	lists = _tmp0_;
#line 973 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = marker;
#line 973 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp1_, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (lists, G_TYPE_OBJECT, GObject));
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = lists->selected;
#line 976 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 977 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = lists->unselected;
#line 977 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 979 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = lists->selected;
#line 979 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = lists->unselected;
#line 979 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 971 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 6046 "ViewCollection.c"
}


static gboolean view_collection_toggle_item (ViewCollection* self, DataObject* object, GObject* user) {
	gboolean result = FALSE;
	DataObject* _tmp0_;
	DataView* _tmp1_;
	DataView* view;
	GObject* _tmp2_;
	ViewCollectionToggleLists* _tmp3_;
	ViewCollectionToggleLists* lists;
	DataView* _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 982 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 982 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 982 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_IS_OBJECT (user), FALSE);
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = object;
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_VIEW, DataView));
#line 983 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = user;
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists));
#line 984 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	lists = _tmp3_;
#line 990 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = view;
#line 990 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = data_view_internal_toggle (_tmp4_);
#line 990 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp5_) {
#line 6084 "ViewCollection.c"
		DataView* _tmp6_;
		gboolean _tmp7_ = FALSE;
#line 991 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = view;
#line 991 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = data_view_is_visible (_tmp6_);
#line 991 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp7_) {
#line 6093 "ViewCollection.c"
			ViewCollectionToggleLists* _tmp8_;
			GeeArrayList* _tmp9_;
			DataView* _tmp10_;
#line 992 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = lists;
#line 992 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_->selected;
#line 992 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 992 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp10_);
#line 6105 "ViewCollection.c"
		}
	} else {
		ViewCollectionToggleLists* _tmp11_;
		GeeArrayList* _tmp12_;
		DataView* _tmp13_;
#line 994 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp11_ = lists;
#line 994 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp12_ = _tmp11_->unselected;
#line 994 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp13_ = view;
#line 994 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp13_);
#line 6119 "ViewCollection.c"
	}
#line 997 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 997 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 997 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 997 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6129 "ViewCollection.c"
}


gint view_collection_get_selected_count (ViewCollection* self) {
	gint result = 0;
	DataSet* _tmp0_;
	gint _tmp1_ = 0;
#line 1000 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1001 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1001 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_count (_tmp0_);
#line 1001 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp1_;
#line 1001 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6147 "ViewCollection.c"
}


GeeList* view_collection_get_selected (ViewCollection* self) {
	GeeList* result = NULL;
	DataSet* _tmp0_;
	GeeList* _tmp1_ = NULL;
#line 1004 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1005 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1005 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_all (_tmp0_);
#line 1005 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 1005 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6165 "ViewCollection.c"
}


DataView* view_collection_get_selected_at (ViewCollection* self, gint index) {
	DataView* result = NULL;
	DataSet* _tmp0_;
	gint _tmp1_;
	DataObject* _tmp2_ = NULL;
#line 1008 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = index;
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_set_get_at (_tmp0_, _tmp1_);
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_VIEW, DataView);
#line 1009 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6186 "ViewCollection.c"
}


static gboolean view_collection_is_visible (ViewCollection* self, DataView* view) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	DataSet* _tmp1_;
#line 1012 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1012 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 6202 "ViewCollection.c"
		DataSet* _tmp2_;
		DataView* _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = data_set_contains (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_OBJECT, DataObject));
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 6214 "ViewCollection.c"
	} else {
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 6218 "ViewCollection.c"
	}
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_;
#line 1013 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6224 "ViewCollection.c"
}


static gboolean view_collection_add_many_visible (ViewCollection* self, GeeCollection* many) {
	gboolean result = FALSE;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
	GeeCollection* _tmp2_;
	gboolean _tmp3_ = FALSE;
	DataSet* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
#line 1016 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1016 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (many), FALSE);
#line 1017 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->visible;
#line 1017 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp0_ == NULL) {
#line 1018 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = TRUE;
#line 1018 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 6249 "ViewCollection.c"
	}
#line 1020 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1020 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = many;
#line 1020 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = data_set_add_many (_tmp1_, _tmp2_);
#line 1020 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp3_) {
#line 1021 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = FALSE;
#line 1021 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 6263 "ViewCollection.c"
	}
#line 1024 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = self->priv->visible;
#line 1024 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = data_set_get_count (_tmp4_);
#line 1024 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1024 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp5_ == _tmp6_) {
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1025 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		self->priv->visible = NULL;
#line 6277 "ViewCollection.c"
	}
#line 1027 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 1027 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6283 "ViewCollection.c"
}


static void view_collection_hide_items (ViewCollection* self, GeeList* to_hide) {
	GeeArrayList* _tmp0_;
	GeeArrayList* unselected;
	GeeList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint count;
	DataSet* _tmp23_;
	DataSet* _tmp25_;
	GeeList* _tmp26_;
	gboolean _tmp27_ = FALSE;
	gboolean removed;
	gboolean _tmp28_;
	GeeArrayList* _tmp29_;
	GeeArrayList* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GeeList* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_hide));
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1032 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 1034 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = to_hide;
#line 1034 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1034 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1034 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	count = _tmp3_;
#line 6323 "ViewCollection.c"
	{
		gint ctr;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		ctr = 0;
#line 6328 "ViewCollection.c"
		{
			gboolean _tmp4_;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = TRUE;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6335 "ViewCollection.c"
				gboolean _tmp5_;
				gint _tmp7_;
				gint _tmp8_;
				GeeList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_ = NULL;
				DataView* view;
				DataView* _tmp12_;
				gboolean _tmp13_ = FALSE;
				DataView* _tmp14_;
				gboolean _tmp15_ = FALSE;
				DataView* _tmp22_;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp5_ = _tmp4_;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!_tmp5_) {
#line 6352 "ViewCollection.c"
					gint _tmp6_;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp6_ = ctr;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					ctr = _tmp6_ + 1;
#line 6358 "ViewCollection.c"
				}
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp4_ = FALSE;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp7_ = ctr;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp8_ = count;
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					break;
#line 6370 "ViewCollection.c"
				}
#line 1036 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp9_ = to_hide;
#line 1036 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp10_ = ctr;
#line 1036 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp11_ = gee_list_get (_tmp9_, _tmp10_);
#line 1036 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				view = (DataView*) _tmp11_;
#line 1037 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 1037 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = data_view_is_visible (_tmp12_);
#line 1037 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_vala_assert (_tmp13_, "view.is_visible()");
#line 1039 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 1039 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp15_ = data_view_is_selected (_tmp14_);
#line 1039 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp15_) {
#line 6392 "ViewCollection.c"
					DataView* _tmp16_;
					GeeArrayList* _tmp17_;
					DataView* _tmp18_;
#line 1040 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp16_ = view;
#line 1040 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					data_view_internal_set_selected (_tmp16_, FALSE);
#line 1041 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp17_ = unselected;
#line 1041 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp18_ = view;
#line 1041 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp18_);
#line 6406 "ViewCollection.c"
				} else {
					DataSet* _tmp19_;
					DataView* _tmp20_;
					gboolean _tmp21_ = FALSE;
#line 1043 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp19_ = self->priv->selected;
#line 1043 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp20_ = view;
#line 1043 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp21_ = data_set_contains (_tmp19_, G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_DATA_OBJECT, DataObject));
#line 1043 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_vala_assert (!_tmp21_, "!selected.contains(view)");
#line 6419 "ViewCollection.c"
				}
#line 1046 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp22_ = view;
#line 1046 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp22_, FALSE);
#line 1035 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6427 "ViewCollection.c"
			}
		}
	}
#line 1049 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp23_ = self->priv->visible;
#line 1049 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp23_ == NULL) {
#line 6435 "ViewCollection.c"
		DataSet* _tmp24_ = NULL;
#line 1051 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp24_ = data_collection_get_dataset_copy (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1051 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1051 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		self->priv->visible = _tmp24_;
#line 6443 "ViewCollection.c"
	}
#line 1054 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp25_ = self->priv->visible;
#line 1054 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp26_ = to_hide;
#line 1054 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp27_ = data_set_remove_many (_tmp25_, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1054 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	removed = _tmp27_;
#line 1055 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp28_ = removed;
#line 1055 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (_tmp28_, "removed");
#line 1057 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp29_ = unselected;
#line 1057 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1059 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp30_ = unselected;
#line 1059 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp31_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1059 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp32_ = _tmp31_;
#line 1059 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp32_ > 0) {
#line 6469 "ViewCollection.c"
		GeeArrayList* _tmp33_;
#line 1060 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp33_ = unselected;
#line 1060 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_COLLECTION, GeeCollection));
#line 6475 "ViewCollection.c"
	}
#line 1062 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp34_ = to_hide;
#line 1062 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp35_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1062 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp36_ = _tmp35_;
#line 1062 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp36_ > 0) {
#line 6485 "ViewCollection.c"
		GeeList* _tmp37_;
		GeeList* _tmp38_;
#line 1063 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp37_ = to_hide;
#line 1063 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_hidden (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1064 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp38_ = to_hide;
#line 1064 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_COLLECTION, GeeCollection));
#line 6496 "ViewCollection.c"
	}
#line 1031 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 6500 "ViewCollection.c"
}


static void view_collection_show_items (ViewCollection* self, GeeList* to_show) {
	GeeArrayList* _tmp0_;
	GeeArrayList* added_selected;
	GeeList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint count;
	GeeList* _tmp22_;
	gboolean _tmp23_ = FALSE;
	gboolean added;
	gboolean _tmp24_;
	GeeArrayList* _tmp25_;
	GeeList* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
#line 1069 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1069 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_LIST (to_show));
#line 1070 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1070 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	added_selected = _tmp0_;
#line 1072 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = to_show;
#line 1072 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1072 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1072 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	count = _tmp3_;
#line 6535 "ViewCollection.c"
	{
		gint ctr;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		ctr = 0;
#line 6540 "ViewCollection.c"
		{
			gboolean _tmp4_;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = TRUE;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			while (TRUE) {
#line 6547 "ViewCollection.c"
				gboolean _tmp5_;
				gint _tmp7_;
				gint _tmp8_;
				GeeList* _tmp9_;
				gint _tmp10_;
				gpointer _tmp11_ = NULL;
				DataView* view;
				DataView* _tmp12_;
				gboolean _tmp13_ = FALSE;
				DataView* _tmp14_;
				DataView* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp5_ = _tmp4_;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!_tmp5_) {
#line 6564 "ViewCollection.c"
					gint _tmp6_;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp6_ = ctr;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					ctr = _tmp6_ + 1;
#line 6570 "ViewCollection.c"
				}
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp4_ = FALSE;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp7_ = ctr;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp8_ = count;
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					break;
#line 6582 "ViewCollection.c"
				}
#line 1074 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp9_ = to_show;
#line 1074 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp10_ = ctr;
#line 1074 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp11_ = gee_list_get (_tmp9_, _tmp10_);
#line 1074 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				view = (DataView*) _tmp11_;
#line 1075 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 1075 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = data_view_is_visible (_tmp12_);
#line 1075 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_vala_assert (!_tmp13_, "!view.is_visible()");
#line 1077 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 1077 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp14_, TRUE);
#line 1080 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp15_ = view;
#line 1080 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = data_view_is_selected (_tmp15_);
#line 1080 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp16_) {
#line 6608 "ViewCollection.c"
					DataSet* _tmp17_;
					DataView* _tmp18_;
					gboolean _tmp19_ = FALSE;
					GeeArrayList* _tmp20_;
					DataView* _tmp21_;
#line 1081 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp17_ = self->priv->selected;
#line 1081 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp18_ = view;
#line 1081 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp19_ = data_set_contains (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_DATA_OBJECT, DataObject));
#line 1081 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_vala_assert (!_tmp19_, "!selected.contains(view)");
#line 1082 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp20_ = added_selected;
#line 1082 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp21_ = view;
#line 1082 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp21_);
#line 6628 "ViewCollection.c"
				}
#line 1073 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6632 "ViewCollection.c"
			}
		}
	}
#line 1086 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp22_ = to_show;
#line 1086 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp23_ = view_collection_add_many_visible (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1086 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	added = _tmp23_;
#line 1087 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp24_ = added;
#line 1087 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (_tmp24_, "added");
#line 1089 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp25_ = added_selected;
#line 1089 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1091 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp26_ = to_show;
#line 1091 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp27_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1091 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp28_ = _tmp27_;
#line 1091 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp28_ > 0) {
#line 6658 "ViewCollection.c"
		GeeList* _tmp29_;
		GeeList* _tmp30_;
#line 1092 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp29_ = to_show;
#line 1092 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_shown (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1093 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp30_ = to_show;
#line 1093 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_COLLECTION, GeeCollection));
#line 6669 "ViewCollection.c"
	}
#line 1069 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 6673 "ViewCollection.c"
}


gboolean view_collection_has_view_for_source (ViewCollection* self, DataSource* source) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* _tmp2_;
	gboolean _tmp3_;
#line 1098 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1098 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1099 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = source;
#line 1099 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source (self, _tmp0_);
#line 1099 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1099 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 1099 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp2_);
#line 1099 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 1099 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6701 "ViewCollection.c"
}


DataView* view_collection_get_view_for_source (ViewCollection* self, DataSource* source) {
	DataView* result = NULL;
	GeeHashMap* _tmp0_;
	DataSource* _tmp1_;
	gpointer _tmp2_ = NULL;
#line 1103 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1103 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = source;
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = (DataView*) _tmp2_;
#line 1104 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6724 "ViewCollection.c"
}


gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self, DataSource* source) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* _tmp2_;
	gboolean _tmp3_;
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1108 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1109 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = source;
#line 1109 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source_filtered (self, _tmp0_);
#line 1109 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1109 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_ != NULL;
#line 1109 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp2_);
#line 1109 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 1109 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6752 "ViewCollection.c"
}


DataView* view_collection_get_view_for_source_filtered (ViewCollection* self, DataSource* source) {
	DataView* result = NULL;
	GeeHashMap* _tmp0_;
	DataSource* _tmp1_;
	gpointer _tmp2_ = NULL;
	DataView* view;
	gboolean _tmp3_ = FALSE;
	DataView* _tmp4_;
	gboolean _tmp7_;
#line 1113 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1113 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1114 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1114 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = source;
#line 1114 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp1_);
#line 1114 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view = (DataView*) _tmp2_;
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = view;
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp4_ != NULL) {
#line 6781 "ViewCollection.c"
		DataView* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = view;
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = view_collection_is_in_filter (self, _tmp5_);
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = !_tmp6_;
#line 6790 "ViewCollection.c"
	} else {
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 6794 "ViewCollection.c"
	}
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = _tmp3_;
#line 1116 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp7_) {
#line 1117 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		result = NULL;
#line 1117 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 1117 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return result;
#line 6806 "ViewCollection.c"
	}
#line 1118 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = view;
#line 1118 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6812 "ViewCollection.c"
}


GeeCollection* view_collection_get_sources (ViewCollection* self) {
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeCollection* _tmp6_;
#line 1122 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap));
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = gee_set_get_read_only_view (_tmp3_);
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp3_);
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp6_;
#line 1123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6847 "ViewCollection.c"
}


gboolean view_collection_has_source_of_type (ViewCollection* self, GType t) {
	gboolean result = FALSE;
	GType _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 1127 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1128 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = t;
#line 1128 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = g_type_is_a (_tmp0_, TYPE_DATA_SOURCE);
#line 1128 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (_tmp1_, "t.is_a(typeof(DataSource))");
#line 6863 "ViewCollection.c"
	{
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_;
		GeeIterator* _source_it;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = self->priv->source_map;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_MAP, GeeMap));
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = _tmp6_;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp5_);
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_source_it = _tmp7_;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6890 "ViewCollection.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			DataSource* source;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = _source_it;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp9_) {
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 6908 "ViewCollection.c"
			}
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = _source_it;
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			source = (DataSource*) _tmp11_;
#line 1131 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1131 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, G_TYPE_OBJECT, GObject));
#line 1131 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1131 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1131 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				result = TRUE;
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_source_it);
#line 1132 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				return result;
#line 6934 "ViewCollection.c"
			}
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 6938 "ViewCollection.c"
		}
#line 1130 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 6942 "ViewCollection.c"
	}
#line 1135 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = FALSE;
#line 1135 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 6948 "ViewCollection.c"
}


gint view_collection_get_sources_of_type_count (ViewCollection* self, GType t) {
	gint result = 0;
	GType _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint count;
#line 1138 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1139 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = t;
#line 1139 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = g_type_is_a (_tmp0_, TYPE_DATA_SOURCE);
#line 1139 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (_tmp1_, "t.is_a(typeof(DataSource))");
#line 1141 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	count = 0;
#line 6967 "ViewCollection.c"
	{
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 6988 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			DataObject* _tmp10_;
			DataSource* _tmp11_ = NULL;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 7009 "ViewCollection.c"
			}
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_VIEW, DataView));
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = _tmp11_;
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, G_TYPE_OBJECT, GObject));
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp16_ = _tmp15_;
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp12_);
#line 1143 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp16_) {
#line 7035 "ViewCollection.c"
				gint _tmp17_;
#line 1144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp17_ = count;
#line 1144 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				count = _tmp17_ + 1;
#line 7041 "ViewCollection.c"
			}
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 7045 "ViewCollection.c"
		}
#line 1142 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 7049 "ViewCollection.c"
	}
#line 1147 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = count;
#line 1147 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 7055 "ViewCollection.c"
}


GeeList* view_collection_get_sources_of_type (ViewCollection* self, GType t) {
	GeeList* result = NULL;
	GType _tmp0_;
	gboolean _tmp1_ = FALSE;
	GeeList* sources;
#line 1150 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1151 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = t;
#line 1151 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = g_type_is_a (_tmp0_, TYPE_DATA_SOURCE);
#line 1151 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_vala_assert (_tmp1_, "t.is_a(typeof(DataSource))");
#line 1153 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	sources = NULL;
#line 7074 "ViewCollection.c"
	{
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_object_it = _tmp5_;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 7095 "ViewCollection.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			DataObject* _tmp10_;
			DataSource* _tmp11_ = NULL;
			DataSource* source;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!_tmp7_) {
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 7116 "ViewCollection.c"
			}
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = _object_it;
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			object = (DataObject*) _tmp9_;
#line 1155 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 1155 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_VIEW, DataView));
#line 1155 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			source = _tmp11_;
#line 1156 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1156 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, G_TYPE_OBJECT, GObject));
#line 1156 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1156 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1156 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 7140 "ViewCollection.c"
				GeeList* _tmp16_;
				GeeList* _tmp18_;
				DataSource* _tmp19_;
#line 1157 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = sources;
#line 1157 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp16_ == NULL) {
#line 7148 "ViewCollection.c"
					GeeArrayList* _tmp17_;
#line 1158 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp17_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1158 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1158 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_LIST, GeeList);
#line 7156 "ViewCollection.c"
				}
#line 1160 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp18_ = sources;
#line 1160 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = source;
#line 1160 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection), _tmp19_);
#line 7164 "ViewCollection.c"
			}
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 7170 "ViewCollection.c"
		}
#line 1154 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 7174 "ViewCollection.c"
	}
#line 1164 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = sources;
#line 1164 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 7180 "ViewCollection.c"
}


GeeList* view_collection_get_selected_sources (ViewCollection* self) {
	GeeList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeList* sources;
	DataSet* _tmp1_;
	gint _tmp2_ = 0;
	gint count;
#line 1167 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1168 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1168 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1170 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->priv->selected;
#line 1170 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_set_get_count (_tmp1_);
#line 1170 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	count = _tmp2_;
#line 7203 "ViewCollection.c"
	{
		gint ctr;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		ctr = 0;
#line 7208 "ViewCollection.c"
		{
			gboolean _tmp3_;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			while (TRUE) {
#line 7215 "ViewCollection.c"
				gboolean _tmp4_;
				gint _tmp6_;
				gint _tmp7_;
				GeeList* _tmp8_;
				DataSet* _tmp9_;
				gint _tmp10_;
				DataObject* _tmp11_ = NULL;
				DataView* _tmp12_;
				DataSource* _tmp13_ = NULL;
				DataSource* _tmp14_;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp4_ = _tmp3_;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!_tmp4_) {
#line 7230 "ViewCollection.c"
					gint _tmp5_;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp5_ = ctr;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					ctr = _tmp5_ + 1;
#line 7236 "ViewCollection.c"
				}
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp6_ = ctr;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp7_ = count;
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 1171 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					break;
#line 7248 "ViewCollection.c"
				}
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp8_ = sources;
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp9_ = self->priv->selected;
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp10_ = ctr;
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp11_ = data_set_get_at (_tmp9_, _tmp10_);
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp12_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_DATA_VIEW, DataView);
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = data_view_get_source (_tmp12_);
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection), _tmp14_);
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 1172 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp12_);
#line 7270 "ViewCollection.c"
			}
		}
	}
#line 1174 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = sources;
#line 1174 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 7278 "ViewCollection.c"
}


DataSource* view_collection_get_selected_source_at (ViewCollection* self, gint index) {
	DataSource* result = NULL;
	DataSet* _tmp0_;
	gint _tmp1_;
	DataObject* _tmp2_ = NULL;
	DataObject* object;
	DataSource* _tmp3_ = NULL;
	DataObject* _tmp4_;
#line 1177 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1178 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1178 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = index;
#line 1178 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_set_get_at (_tmp0_, _tmp1_);
#line 1178 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	object = _tmp2_;
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = object;
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp4_ != NULL) {
#line 7304 "ViewCollection.c"
		DataObject* _tmp5_;
		DataSource* _tmp6_ = NULL;
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = object;
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp6_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView));
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = _tmp6_;
#line 7315 "ViewCollection.c"
	} else {
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = NULL;
#line 7321 "ViewCollection.c"
	}
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp3_;
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (object);
#line 1180 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 7329 "ViewCollection.c"
}


GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self, GType t) {
	GeeList* result = NULL;
	GeeList* sources;
#line 1183 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1184 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	sources = NULL;
#line 7340 "ViewCollection.c"
	{
		GeeList* _tmp0_ = NULL;
		GeeList* _view_list;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _view_size;
		gint _view_index;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp0_ = view_collection_get_selected (self);
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_view_list = _tmp0_;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = _view_list;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_view_size = _tmp3_;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_view_index = -1;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		while (TRUE) {
#line 7365 "ViewCollection.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			GeeList* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_ = NULL;
			DataView* view;
			DataView* _tmp10_;
			DataSource* _tmp11_ = NULL;
			DataSource* source;
			DataSource* _tmp12_;
			GType _tmp13_ = 0UL;
			GType _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp4_ = _view_index;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_view_index = _tmp4_ + 1;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp5_ = _view_index;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = _view_size;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				break;
#line 7392 "ViewCollection.c"
			}
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp7_ = _view_list;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp8_ = _view_index;
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp9_ = gee_list_get (_tmp7_, _tmp8_);
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			view = (DataView*) _tmp9_;
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (_tmp10_);
#line 1186 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			source = _tmp11_;
#line 1187 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp12_ = source;
#line 1187 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp13_ = G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, G_TYPE_OBJECT, GObject));
#line 1187 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp14_ = t;
#line 1187 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp15_ = g_type_is_a (_tmp13_, _tmp14_);
#line 1187 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 7418 "ViewCollection.c"
				GeeList* _tmp16_;
				GeeList* _tmp18_;
				DataSource* _tmp19_;
#line 1188 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = sources;
#line 1188 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (_tmp16_ == NULL) {
#line 7426 "ViewCollection.c"
					GeeArrayList* _tmp17_;
#line 1189 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_tmp17_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 1189 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1189 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_LIST, GeeList);
#line 7434 "ViewCollection.c"
				}
#line 1191 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp18_ = sources;
#line 1191 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp19_ = source;
#line 1191 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection), _tmp19_);
#line 7442 "ViewCollection.c"
			}
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 7448 "ViewCollection.c"
		}
#line 1185 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_view_list);
#line 7452 "ViewCollection.c"
	}
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = sources;
#line 1195 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 7458 "ViewCollection.c"
}


gint view_collection_index_of_source (ViewCollection* self, DataSource* source) {
	gint result = 0;
	DataSource* _tmp0_;
	DataView* _tmp1_ = NULL;
	DataView* view;
	gint _tmp2_ = 0;
	DataView* _tmp3_;
#line 1199 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1199 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0);
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = source;
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = view_collection_get_view_for_source (self, _tmp0_);
#line 1200 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view = _tmp1_;
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = view;
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 7483 "ViewCollection.c"
		DataView* _tmp4_;
		gint _tmp5_ = 0;
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = view;
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_OBJECT, DataObject));
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = _tmp5_;
#line 7492 "ViewCollection.c"
	} else {
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = -1;
#line 7496 "ViewCollection.c"
	}
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1202 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 7504 "ViewCollection.c"
}


void view_collection_internal_notify_view_altered (ViewCollection* self, DataView* view) {
	gboolean _tmp0_ = FALSE;
#line 1206 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1206 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1207 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_are_notifications_frozen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1207 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp0_) {
#line 7518 "ViewCollection.c"
		DataView* _tmp1_;
		DataView* _tmp2_;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = view;
#line 1208 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_item_view_altered (self, _tmp1_);
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = view;
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = data_collection_get_singleton (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_OBJECT, DataObject));
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, _tmp4_);
#line 1209 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp4_);
#line 7537 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp5_;
		GeeHashSet* _tmp7_;
		DataView* _tmp8_;
#line 1211 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = self->priv->frozen_views_altered;
#line 1211 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp5_ == NULL) {
#line 7546 "ViewCollection.c"
			GeeHashSet* _tmp6_;
#line 1212 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 1212 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_views_altered);
#line 1212 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			self->priv->frozen_views_altered = _tmp6_;
#line 7554 "ViewCollection.c"
		}
#line 1213 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = self->priv->frozen_views_altered;
#line 1213 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp8_ = view;
#line 1213 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp8_);
#line 7562 "ViewCollection.c"
	}
}


void view_collection_internal_notify_geometry_altered (ViewCollection* self, DataView* view) {
	gboolean _tmp0_ = FALSE;
#line 1218 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1218 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1219 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = data_collection_are_notifications_frozen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1219 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!_tmp0_) {
#line 7577 "ViewCollection.c"
		DataView* _tmp1_;
		DataView* _tmp2_;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_;
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp1_ = view;
#line 1220 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_item_geometry_altered (self, _tmp1_);
#line 1221 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp2_ = view;
#line 1221 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp3_ = data_collection_get_singleton (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_OBJECT, DataObject));
#line 1221 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1221 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp4_);
#line 1221 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp4_);
#line 7596 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp5_;
		GeeHashSet* _tmp7_;
		DataView* _tmp8_;
#line 1223 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp5_ = self->priv->frozen_geometries_altered;
#line 1223 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (_tmp5_ == NULL) {
#line 7605 "ViewCollection.c"
			GeeHashSet* _tmp6_;
#line 1224 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp6_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 1224 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1224 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			self->priv->frozen_geometries_altered = _tmp6_;
#line 7613 "ViewCollection.c"
		}
#line 1225 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp7_ = self->priv->frozen_geometries_altered;
#line 1225 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp8_ = view;
#line 1225 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp8_);
#line 7621 "ViewCollection.c"
	}
}


static void view_collection_real_notify_thawed (DataCollection* base) {
	ViewCollection * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp9_;
#line 1229 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 1230 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->priv->frozen_views_altered;
#line 1230 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 7636 "ViewCollection.c"
		GeeHashSet* _tmp8_;
		{
			GeeHashSet* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _view_it;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp1_ = self->priv->frozen_views_altered;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp2_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_view_it = _tmp2_;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			while (TRUE) {
#line 7650 "ViewCollection.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				DataView* view;
				DataView* _tmp7_;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp3_ = _view_it;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!_tmp4_) {
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					break;
#line 7665 "ViewCollection.c"
				}
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp5_ = _view_it;
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				view = (DataView*) _tmp6_;
#line 1232 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp7_ = view;
#line 1232 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				view_collection_notify_item_view_altered (self, _tmp7_);
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7679 "ViewCollection.c"
			}
#line 1231 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7683 "ViewCollection.c"
		}
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp8_ = self->priv->frozen_views_altered;
#line 1233 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_views_altered);
#line 1234 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		self->priv->frozen_views_altered = NULL;
#line 7693 "ViewCollection.c"
	}
#line 1237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp9_ = self->priv->frozen_geometries_altered;
#line 1237 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (_tmp9_ != NULL) {
#line 7699 "ViewCollection.c"
		GeeHashSet* _tmp17_;
		{
			GeeHashSet* _tmp10_;
			GeeIterator* _tmp11_ = NULL;
			GeeIterator* _view_it;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp10_ = self->priv->frozen_geometries_altered;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_tmp11_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_view_it = _tmp11_;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			while (TRUE) {
#line 7713 "ViewCollection.c"
				GeeIterator* _tmp12_;
				gboolean _tmp13_ = FALSE;
				GeeIterator* _tmp14_;
				gpointer _tmp15_ = NULL;
				DataView* view;
				DataView* _tmp16_;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp12_ = _view_it;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				if (!_tmp13_) {
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
					break;
#line 7728 "ViewCollection.c"
				}
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp14_ = _view_it;
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				view = (DataView*) _tmp15_;
#line 1239 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_tmp16_ = view;
#line 1239 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				view_collection_notify_item_geometry_altered (self, _tmp16_);
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7742 "ViewCollection.c"
			}
#line 1238 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7746 "ViewCollection.c"
		}
#line 1240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_tmp17_ = self->priv->frozen_geometries_altered;
#line 1240 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1241 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1241 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		self->priv->frozen_geometries_altered = NULL;
#line 7756 "ViewCollection.c"
	}
#line 1244 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 7760 "ViewCollection.c"
}


gboolean view_collection_are_items_filtered_out (ViewCollection* self) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 1247 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = _tmp0_ != _tmp1_;
#line 1248 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 7778 "ViewCollection.c"
}


static void view_collection_real_items_selected (ViewCollection* self, GeeIterable* selected) {
#line 76 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (selected));
#line 7785 "ViewCollection.c"
}


static void view_collection_real_items_unselected (ViewCollection* self, GeeIterable* unselected) {
#line 80 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (unselected));
#line 7792 "ViewCollection.c"
}


static void view_collection_real_items_state_changed (ViewCollection* self, GeeIterable* changed) {
#line 84 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_ITERABLE (changed));
#line 7799 "ViewCollection.c"
}


static void view_collection_real_selection_group_altered (ViewCollection* self) {
}


static void view_collection_real_items_shown (ViewCollection* self, GeeCollection* visible) {
#line 95 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (visible));
#line 7810 "ViewCollection.c"
}


static void view_collection_real_items_hidden (ViewCollection* self, GeeCollection* hidden) {
#line 99 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (hidden));
#line 7817 "ViewCollection.c"
}


static void view_collection_real_items_visibility_changed (ViewCollection* self, GeeCollection* changed) {
#line 103 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (changed));
#line 7824 "ViewCollection.c"
}


static void view_collection_real_item_view_altered (ViewCollection* self, DataView* view) {
#line 107 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7831 "ViewCollection.c"
}


static void view_collection_real_item_geometry_altered (ViewCollection* self, DataView* view) {
#line 111 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7838 "ViewCollection.c"
}


static void view_collection_real_views_altered (ViewCollection* self, GeeCollection* views) {
#line 114 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 7845 "ViewCollection.c"
}


static void view_collection_real_geometries_altered (ViewCollection* self, GeeCollection* views) {
#line 117 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (GEE_IS_COLLECTION (views));
#line 7852 "ViewCollection.c"
}


static void view_collection_real_view_filter_installed (ViewCollection* self, ViewFilter* filer) {
#line 120 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filer));
#line 7859 "ViewCollection.c"
}


static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__VIEW_FILTER) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__VIEW_FILTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (n_param_values == 2);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data1 = closure->data;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 7878 "ViewCollection.c"
	} else {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		data2 = closure->data;
#line 7884 "ViewCollection.c"
	}
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	callback = (GMarshalFunc_VOID__VIEW_FILTER) (marshal_data ? marshal_data : cc->callback);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	callback (data1, value_get_view_filter (param_values + 1), data2);
#line 7890 "ViewCollection.c"
}


static void view_collection_real_view_filter_removed (ViewCollection* self, ViewFilter* filer) {
#line 123 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filer));
#line 7897 "ViewCollection.c"
}


ViewCollectionMonitor* view_collection_monitor_construct (GType object_type) {
	ViewCollectionMonitor* self = NULL;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = (ViewCollectionMonitor*) g_type_create_instance (object_type);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self;
#line 7907 "ViewCollection.c"
}


ViewCollectionMonitor* view_collection_monitor_new (void) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return view_collection_monitor_construct (VIEW_COLLECTION_TYPE_MONITOR);
#line 7914 "ViewCollection.c"
}


static void view_collection_value_monitor_init (GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 7921 "ViewCollection.c"
}


static void view_collection_value_monitor_free_value (GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_monitor_unref (value->data[0].v_pointer);
#line 7930 "ViewCollection.c"
	}
}


static void view_collection_value_monitor_copy_value (const GValue* src_value, GValue* dest_value) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_collection_monitor_ref (src_value->data[0].v_pointer);
#line 7940 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7944 "ViewCollection.c"
	}
}


static gpointer view_collection_value_monitor_peek_pointer (const GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 7952 "ViewCollection.c"
}


static gchar* view_collection_value_monitor_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 7959 "ViewCollection.c"
		ViewCollectionMonitor* object;
		object = collect_values[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7966 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7970 "ViewCollection.c"
		}
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_collection_monitor_ref (object);
#line 7974 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 7978 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return NULL;
#line 7982 "ViewCollection.c"
}


static gchar* view_collection_value_monitor_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewCollectionMonitor** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!object_p) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7993 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 7999 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 8003 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = view_collection_monitor_ref (value->data[0].v_pointer);
#line 8007 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return NULL;
#line 8011 "ViewCollection.c"
}


GParamSpec* view_collection_param_spec_monitor (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ViewCollectionParamSpecMonitor* spec;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 8025 "ViewCollection.c"
}


gpointer view_collection_value_get_monitor (const GValue* value) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8034 "ViewCollection.c"
}


void view_collection_value_set_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (v_object) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_monitor_ref (value->data[0].v_pointer);
#line 8054 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8058 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (old) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 8064 "ViewCollection.c"
	}
}


void view_collection_value_take_monitor (GValue* value, gpointer v_object) {
	ViewCollectionMonitor* old;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (v_object) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 8083 "ViewCollection.c"
	} else {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8087 "ViewCollection.c"
	}
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (old) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 8093 "ViewCollection.c"
	}
}


static void view_collection_monitor_class_init (ViewCollectionMonitorClass * klass) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_monitor_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_finalize;
#line 8103 "ViewCollection.c"
}


static void view_collection_monitor_instance_init (ViewCollectionMonitor * self) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 8110 "ViewCollection.c"
}


static void view_collection_monitor_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitor * self;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor);
#line 8118 "ViewCollection.c"
}


GType view_collection_monitor_get_type (void) {
	static volatile gsize view_collection_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { view_collection_value_monitor_init, view_collection_value_monitor_free_value, view_collection_value_monitor_copy_value, view_collection_value_monitor_peek_pointer, "p", view_collection_value_monitor_collect_value, "p", view_collection_value_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitor), 0, (GInstanceInitFunc) view_collection_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_collection_monitor_type_id;
		view_collection_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewCollectionMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&view_collection_monitor_type_id__volatile, view_collection_monitor_type_id);
	}
	return view_collection_monitor_type_id__volatile;
}


gpointer view_collection_monitor_ref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return instance;
#line 8143 "ViewCollection.c"
}


void view_collection_monitor_unref (gpointer instance) {
	ViewCollectionMonitor* self;
	self = instance;
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		VIEW_COLLECTION_MONITOR_GET_CLASS (self)->finalize (self);
#line 22 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8156 "ViewCollection.c"
	}
}


static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender, GeeIterable* added, gpointer self) {
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_sources_added (self, _sender, added);
#line 8164 "ViewCollection.c"
}


static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender, GeeIterable* removed, gpointer self) {
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_sources_removed (self, removed);
#line 8171 "ViewCollection.c"
}


static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_on_sources_altered (self, _sender, items);
#line 8178 "ViewCollection.c"
}


static gpointer _view_manager_ref0 (gpointer self) {
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self ? view_manager_ref (self) : NULL;
#line 8185 "ViewCollection.c"
}


static gpointer _alteration_ref0 (gpointer self) {
#line 36 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self ? alteration_ref (self) : NULL;
#line 8192 "ViewCollection.c"
}


static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type, ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
	ViewCollectionMonitorImpl* self = NULL;
	ViewCollection* _tmp0_;
	ViewCollection* _tmp1_;
	SourceCollection* _tmp2_;
	SourceCollection* _tmp3_;
	ViewManager* _tmp4_;
	ViewManager* _tmp5_;
	Alteration* _tmp6_;
	Alteration* _tmp7_;
	SourceCollection* _tmp8_;
	ViewCollection* _tmp9_;
	SourceCollection* _tmp10_;
	ViewCollection* _tmp11_;
	SourceCollection* _tmp12_;
	ViewCollection* _tmp13_;
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (owner), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = (ViewCollectionMonitorImpl*) view_collection_monitor_construct (object_type);
#line 33 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = owner;
#line 33 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = _data_collection_ref0 (_tmp0_);
#line 33 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 33 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->owner = _tmp1_;
#line 34 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = sources;
#line 34 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = _data_collection_ref0 (_tmp2_);
#line 34 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 34 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->sources = _tmp3_;
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = manager;
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = _view_manager_ref0 (_tmp4_);
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 35 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->manager = _tmp5_;
#line 36 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = prereq;
#line 36 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = _alteration_ref0 (_tmp6_);
#line 36 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 36 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->prereq = _tmp7_;
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp8_ = sources;
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp9_ = owner;
#line 38 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_COLLECTION, DataCollection), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, _tmp9_);
#line 39 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp10_ = sources;
#line 39 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp11_ = owner;
#line 39 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_COLLECTION, DataCollection), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, _tmp11_);
#line 40 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp12_ = sources;
#line 40 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp13_ = owner;
#line 40 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_DATA_COLLECTION, DataCollection), "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, _tmp13_);
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self;
#line 8274 "ViewCollection.c"
}


static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner, SourceCollection* sources, ViewManager* manager, Alteration* prereq) {
#line 31 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return view_collection_monitor_impl_construct (VIEW_COLLECTION_TYPE_MONITOR_IMPL, owner, sources, manager, prereq);
#line 8281 "ViewCollection.c"
}


static void view_collection_monitor_impl_class_init (ViewCollectionMonitorImplClass * klass) {
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_monitor_impl_parent_class = g_type_class_peek_parent (klass);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (klass)->finalize = view_collection_monitor_impl_finalize;
#line 8290 "ViewCollection.c"
}


static void view_collection_monitor_impl_instance_init (ViewCollectionMonitorImpl * self) {
}


static void view_collection_monitor_impl_finalize (ViewCollectionMonitor* obj) {
	ViewCollectionMonitorImpl * self;
	SourceCollection* _tmp0_;
	ViewCollection* _tmp1_;
	guint _tmp2_ = 0U;
	SourceCollection* _tmp3_;
	ViewCollection* _tmp4_;
	guint _tmp5_ = 0U;
	SourceCollection* _tmp6_;
	ViewCollection* _tmp7_;
	guint _tmp8_ = 0U;
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl);
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = self->sources;
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = self->owner;
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 44 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, _tmp1_);
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = self->sources;
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = self->owner;
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 45 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, _tmp4_);
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = self->sources;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp7_ = self->owner;
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 46 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, _tmp7_);
#line 26 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 27 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 28 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 29 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 25 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (view_collection_monitor_impl_parent_class)->finalize (obj);
#line 8345 "ViewCollection.c"
}


static GType view_collection_monitor_impl_get_type (void) {
	static volatile gsize view_collection_monitor_impl_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_monitor_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitorImpl), 0, (GInstanceInitFunc) view_collection_monitor_impl_instance_init, NULL };
		GType view_collection_monitor_impl_type_id;
		view_collection_monitor_impl_type_id = g_type_register_static (VIEW_COLLECTION_TYPE_MONITOR, "ViewCollectionMonitorImpl", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_monitor_impl_type_id__volatile, view_collection_monitor_impl_type_id);
	}
	return view_collection_monitor_impl_type_id__volatile;
}


static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type) {
	ViewCollectionToggleLists * self = NULL;
#line 50 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 50 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self;
#line 8367 "ViewCollection.c"
}


static ViewCollectionToggleLists* view_collection_toggle_lists_new (void) {
#line 50 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 8374 "ViewCollection.c"
}


static void view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass) {
#line 50 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
#line 50 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
#line 8383 "ViewCollection.c"
}


static void view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self) {
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 51 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 51 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->selected = _tmp0_;
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->unselected = _tmp1_;
#line 8398 "ViewCollection.c"
}


static void view_collection_toggle_lists_finalize (GObject* obj) {
	ViewCollectionToggleLists * self;
#line 50 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists);
#line 51 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (self->selected);
#line 52 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (self->unselected);
#line 50 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
#line 8412 "ViewCollection.c"
}


static GType view_collection_toggle_lists_get_type (void) {
	static volatile gsize view_collection_toggle_lists_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_toggle_lists_type_id__volatile, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__volatile;
}


static void view_collection_class_init (ViewCollectionClass * klass) {
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_collection_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->finalize = view_collection_finalize;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_type_class_add_private (klass, sizeof (ViewCollectionPrivate));
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_selected_unselected = view_collection_real_notify_items_selected_unselected;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_selection_group_altered = view_collection_real_notify_selection_group_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_item_view_altered = view_collection_real_notify_item_view_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_views_altered = view_collection_real_notify_views_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_item_geometry_altered = view_collection_real_notify_item_geometry_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_geometries_altered = view_collection_real_notify_geometries_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_shown = view_collection_real_notify_items_shown;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_hidden = view_collection_real_notify_items_hidden;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_items_visibility_changed = view_collection_real_notify_items_visibility_changed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_view_filter_installed = view_collection_real_notify_view_filter_installed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->notify_view_filter_removed = view_collection_real_notify_view_filter_removed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->clear = view_collection_real_clear;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->close = view_collection_real_close;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->valid_type = view_collection_real_valid_type;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->add = view_collection_real_add;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->add_many = view_collection_real_add_many;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->notify_items_added = view_collection_real_notify_items_added;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->notify_items_removed = view_collection_real_notify_items_removed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->items_altered = view_collection_real_items_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->set_comparator = view_collection_real_set_comparator;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->reset_comparator = view_collection_real_reset_comparator;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->get_all = view_collection_real_get_all;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->get_count = view_collection_real_get_count;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->get_at = view_collection_real_get_at;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->index_of = view_collection_real_index_of;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->contains = view_collection_real_contains;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_first = view_collection_real_get_first;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_first_unrejected = view_collection_real_get_first_unrejected;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_last = view_collection_real_get_last;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_next = view_collection_real_get_next;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->get_previous = view_collection_real_get_previous;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (klass)->notify_thawed = view_collection_real_notify_thawed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_selected = view_collection_real_items_selected;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_unselected = view_collection_real_items_unselected;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_state_changed = view_collection_real_items_state_changed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->selection_group_altered = view_collection_real_selection_group_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_shown = view_collection_real_items_shown;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_hidden = view_collection_real_items_hidden;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->item_view_altered = view_collection_real_item_view_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->views_altered = view_collection_real_views_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->geometries_altered = view_collection_real_geometries_altered;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->view_filter_installed = view_collection_real_view_filter_installed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_COLLECTION_CLASS (klass)->view_filter_removed = view_collection_real_view_filter_removed;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("items_selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("items_unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("items_state_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("selection_group_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("items_shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("items_hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("items_visibility_changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("item_view_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("item_geometry_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("views_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("geometries_altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("view_filter_installed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_installed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("view_filter_removed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_removed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 8551 "ViewCollection.c"
}


static void view_collection_instance_init (ViewCollection * self) {
	GeeHashMultiMap* _tmp0_;
	GeeHashSet* _tmp1_;
	DataSet* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GEqualFunc _tmp5_;
	GeeHashMap* _tmp6_;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv = VIEW_COLLECTION_GET_PRIVATE (self);
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, data_collection_unref, VIEW_COLLECTION_TYPE_MONITOR_IMPL, (GBoxedCopyFunc) view_collection_monitor_ref, view_collection_monitor_unref, NULL, NULL, NULL, NULL);
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->monitors = _tmp0_;
#line 61 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 62 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = NULL;
#line 63 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->should_mirror = NULL;
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp1_ = gee_hash_set_new (TYPE_VIEW_FILTER, (GBoxedCopyFunc) view_filter_ref, view_filter_unref, NULL, NULL);
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->filters = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_SET, GeeSet);
#line 65 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp2_ = data_set_new ();
#line 65 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->selected = _tmp2_;
#line 66 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->visible = NULL;
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->frozen_views_altered = NULL;
#line 68 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->frozen_geometries_altered = NULL;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp3_ = g_direct_hash;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp4_ = g_direct_equal;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp5_ = g_direct_equal;
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_tmp6_ = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp3_, _tmp4_, _tmp5_);
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->priv->source_map = _tmp6_;
#line 8599 "ViewCollection.c"
}


static void view_collection_finalize (DataCollection* obj) {
	ViewCollection * self;
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_COLLECTION, ViewCollection);
#line 59 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->monitors);
#line 61 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 64 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->filters);
#line 65 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->selected);
#line 66 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->visible);
#line 67 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_views_altered);
#line 68 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 72 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->source_map);
#line 21 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
#line 8625 "ViewCollection.c"
}


GType view_collection_get_type (void) {
	static volatile gsize view_collection_type_id__volatile = 0;
	if (g_once_init_enter (&view_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
		GType view_collection_type_id;
		view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
		g_once_init_leave (&view_collection_type_id__volatile, view_collection_type_id);
	}
	return view_collection_type_id__volatile;
}


static gboolean view_manager_real_include_in_view (ViewManager* self, DataSource* source) {
	gboolean result = FALSE;
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1259 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	result = TRUE;
#line 1259 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return result;
#line 8649 "ViewCollection.c"
}


gboolean view_manager_include_in_view (ViewManager* self, DataSource* source) {
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
#line 1258 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->include_in_view (self, source);
#line 8658 "ViewCollection.c"
}


static DataView* view_manager_real_create_view (ViewManager* self, DataSource* source) {
#line 1264 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1264 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return NULL;
#line 8667 "ViewCollection.c"
}


DataView* view_manager_create_view (ViewManager* self, DataSource* source) {
#line 1264 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
#line 1264 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_MANAGER_GET_CLASS (self)->create_view (self, source);
#line 8676 "ViewCollection.c"
}


ViewManager* view_manager_construct (GType object_type) {
	ViewManager* self = NULL;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = (ViewManager*) g_type_create_instance (object_type);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self;
#line 8686 "ViewCollection.c"
}


static void value_view_manager_init (GValue* value) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8693 "ViewCollection.c"
}


static void value_view_manager_free_value (GValue* value) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_manager_unref (value->data[0].v_pointer);
#line 8702 "ViewCollection.c"
	}
}


static void value_view_manager_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
#line 8712 "ViewCollection.c"
	} else {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8716 "ViewCollection.c"
	}
}


static gpointer value_view_manager_peek_pointer (const GValue* value) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8724 "ViewCollection.c"
}


static gchar* value_view_manager_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 8731 "ViewCollection.c"
		ViewManager* object;
		object = collect_values[0].v_pointer;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8738 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8742 "ViewCollection.c"
		}
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_manager_ref (object);
#line 8746 "ViewCollection.c"
	} else {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8750 "ViewCollection.c"
	}
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return NULL;
#line 8754 "ViewCollection.c"
}


static gchar* value_view_manager_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewManager** object_p;
	object_p = collect_values[0].v_pointer;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!object_p) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8765 "ViewCollection.c"
	}
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 8771 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 8775 "ViewCollection.c"
	} else {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = view_manager_ref (value->data[0].v_pointer);
#line 8779 "ViewCollection.c"
	}
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return NULL;
#line 8783 "ViewCollection.c"
}


GParamSpec* param_spec_view_manager (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewManager* spec;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 8797 "ViewCollection.c"
}


gpointer value_get_view_manager (const GValue* value) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8806 "ViewCollection.c"
}


void value_set_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (v_object) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_manager_ref (value->data[0].v_pointer);
#line 8826 "ViewCollection.c"
	} else {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8830 "ViewCollection.c"
	}
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (old) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 8836 "ViewCollection.c"
	}
}


void value_take_view_manager (GValue* value, gpointer v_object) {
	ViewManager* old;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (v_object) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 8855 "ViewCollection.c"
	} else {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8859 "ViewCollection.c"
	}
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (old) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 8865 "ViewCollection.c"
	}
}


static void view_manager_class_init (ViewManagerClass * klass) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_manager_parent_class = g_type_class_peek_parent (klass);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_MANAGER_CLASS (klass)->finalize = view_manager_finalize;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_MANAGER_CLASS (klass)->include_in_view = view_manager_real_include_in_view;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_MANAGER_CLASS (klass)->create_view = view_manager_real_create_view;
#line 8879 "ViewCollection.c"
}


static void view_manager_instance_init (ViewManager * self) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 8886 "ViewCollection.c"
}


static void view_manager_finalize (ViewManager* obj) {
	ViewManager * self;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_MANAGER, ViewManager);
#line 8894 "ViewCollection.c"
}


GType view_manager_get_type (void) {
	static volatile gsize view_manager_type_id__volatile = 0;
	if (g_once_init_enter (&view_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_manager_type_id;
		view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_manager_type_id__volatile, view_manager_type_id);
	}
	return view_manager_type_id__volatile;
}


gpointer view_manager_ref (gpointer instance) {
	ViewManager* self;
	self = instance;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return instance;
#line 8919 "ViewCollection.c"
}


void view_manager_unref (gpointer instance) {
	ViewManager* self;
	self = instance;
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
#line 1254 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8932 "ViewCollection.c"
	}
}


static gboolean view_filter_real_predicate (ViewFilter* self, DataView* view) {
#line 1286 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_filter_predicate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1286 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return FALSE;
#line 8942 "ViewCollection.c"
}


gboolean view_filter_predicate (ViewFilter* self, DataView* view) {
#line 1286 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_FILTER (self), FALSE);
#line 1286 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return VIEW_FILTER_GET_CLASS (self)->predicate (self, view);
#line 8951 "ViewCollection.c"
}


ViewFilter* view_filter_construct (GType object_type) {
	ViewFilter* self = NULL;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = (ViewFilter*) g_type_create_instance (object_type);
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return self;
#line 8961 "ViewCollection.c"
}


static void view_filter_real_refresh (ViewFilter* self) {
}


static void value_view_filter_init (GValue* value) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8972 "ViewCollection.c"
}


static void value_view_filter_free_value (GValue* value) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_filter_unref (value->data[0].v_pointer);
#line 8981 "ViewCollection.c"
	}
}


static void value_view_filter_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_filter_ref (src_value->data[0].v_pointer);
#line 8991 "ViewCollection.c"
	} else {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8995 "ViewCollection.c"
	}
}


static gpointer value_view_filter_peek_pointer (const GValue* value) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 9003 "ViewCollection.c"
}


static gchar* value_view_filter_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 9010 "ViewCollection.c"
		ViewFilter* object;
		object = collect_values[0].v_pointer;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9017 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9021 "ViewCollection.c"
		}
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_filter_ref (object);
#line 9025 "ViewCollection.c"
	} else {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9029 "ViewCollection.c"
	}
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return NULL;
#line 9033 "ViewCollection.c"
}


static gchar* value_view_filter_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ViewFilter** object_p;
	object_p = collect_values[0].v_pointer;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!object_p) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9044 "ViewCollection.c"
	}
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = NULL;
#line 9050 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 9054 "ViewCollection.c"
	} else {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		*object_p = view_filter_ref (value->data[0].v_pointer);
#line 9058 "ViewCollection.c"
	}
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return NULL;
#line 9062 "ViewCollection.c"
}


GParamSpec* param_spec_view_filter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecViewFilter* spec;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_FILTER), NULL);
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 9076 "ViewCollection.c"
}


gpointer value_get_view_filter (const GValue* value) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER), NULL);
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 9085 "ViewCollection.c"
}


void value_set_view_filter (GValue* value, gpointer v_object) {
	ViewFilter* old;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (v_object) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_filter_ref (value->data[0].v_pointer);
#line 9105 "ViewCollection.c"
	} else {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9109 "ViewCollection.c"
	}
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (old) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 9115 "ViewCollection.c"
	}
}


void value_take_view_filter (GValue* value, gpointer v_object) {
	ViewFilter* old;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (v_object) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 9134 "ViewCollection.c"
	} else {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9138 "ViewCollection.c"
	}
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (old) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 9144 "ViewCollection.c"
	}
}


static void view_filter_class_init (ViewFilterClass * klass) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	view_filter_parent_class = g_type_class_peek_parent (klass);
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_FILTER_CLASS (klass)->finalize = view_filter_finalize;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_FILTER_CLASS (klass)->predicate = view_filter_real_predicate;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	VIEW_FILTER_CLASS (klass)->refresh = view_filter_real_refresh;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_signal_new ("refresh", TYPE_VIEW_FILTER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewFilterClass, refresh), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9160 "ViewCollection.c"
}


static void view_filter_instance_init (ViewFilter * self) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 9167 "ViewCollection.c"
}


static void view_filter_finalize (ViewFilter* obj) {
	ViewFilter * self;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_FILTER, ViewFilter);
#line 9175 "ViewCollection.c"
}


GType view_filter_get_type (void) {
	static volatile gsize view_filter_type_id__volatile = 0;
	if (g_once_init_enter (&view_filter_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_view_filter_init, value_view_filter_free_value, value_view_filter_copy_value, value_view_filter_peek_pointer, "p", value_view_filter_collect_value, "p", value_view_filter_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewFilter), 0, (GInstanceInitFunc) view_filter_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType view_filter_type_id;
		view_filter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewFilter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&view_filter_type_id__volatile, view_filter_type_id);
	}
	return view_filter_type_id__volatile;
}


gpointer view_filter_ref (gpointer instance) {
	ViewFilter* self;
	self = instance;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	return instance;
#line 9200 "ViewCollection.c"
}


void view_filter_unref (gpointer instance) {
	ViewFilter* self;
	self = instance;
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		VIEW_FILTER_GET_CLASS (self)->finalize (self);
#line 1279 "/builddir/build/BUILD/shotwell-0.14.1/src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9213 "ViewCollection.c"
	}
}



